SLASH_GC1 = "/GearCheck";
SLASH_GC2 = "/gc";
local GearCheckVersionNumber = "3.5";
local GearCheckVersion = "GearCheck v"..GearCheckVersionNumber;
local GearCheckVersionShort = "(v"..GearCheckVersionNumber..")";
local waitTable = {};
local waittime = 0;
local time = 0;
local GameTooltipOnShow = -1;
local GearCheckRealm = GetRealmName();
local GearCheckFrameSChildContentTable = {};
local GearCheckCurrentResults = {};
local GearCheckMaxWidth = (GetScreenWidth() - 50);
local GearCheckMaxHeight = (GetScreenHeight() - 50);
local GearCheckCurrentNamesList = {};
local GearCheckNumChecked = 0;
local showUpdateMessage = true;
local GearCheckPlayerStatus = 0;
local GearCheckDebug = false;

local GearCheckDefaultAdditionalWaittime = 0.3;
local GearCheckDefaultNumInspections = 5;

--begin localization
local L = {};
L["requestGC"] = "Perform GearCheck";
L["runningGC"] = "Running GearCheck"
L["PartyReport"] = "Party-GearCheck "..GearCheckVersionShort..":";
L["RaidReport"] = "Raid-GearCheck "..GearCheckVersionShort..":";
L["GuildReport"] = "Guild-GearCheck "..GearCheckVersionShort..":";
L["TargetReport"] = "Gear-Check "..GearCheckVersionShort.." of ";
L["requestinformation"] = "RIL = Real-Item-Level, BIL = Blizzard-Item-Level. There are only targets shown, that are also running this AddOn.";
L["requestinformation2"] = "RIL = Real-Item-Level, BIL = Blizzard-Item-Level. BIL and res. are only shown, if the targets are also running this AddOn.";
L["noAddOn"] = " isn't using this AddOn. There are only targets shown, that are in range or also running this AddOn.";
L["noResponse"] = " isn't responding ";
L["Report:"]="Report:";
L["ChatFrame1"]="ChatFrame1";
L["/say"]="/say";
L["/yell"]="/yell";
L["/party"]="/party";
L["/raid"]="/raid";
L["/guild"]="/guild";
L["/whisper:"]="/whisper:";
L["Options:"]="Options:";
L["lockFrames"]="Lock Frames";
L["enableMinimapButton"]="Enable Minimap-Button";
L["lockMinimapButton"]="Lock Minimap-Button";
L["Respond"] = "Respond to GC-Requests";	
L["Check:"] = "Check:";
L["party"] = "Party";
L["raid"] = "Raid";
L["guild"] = "Guild";
L["target"] = "Target: ";
L["resiliance"] = " res.";
L["resi"] = "res.";
L["Head"] = "# || RIL || BIL || name (res.)";
L["REALITEMLEVEL"] = "The average Item-Level of Your current Equip.";
L["GCdisabled"] = "GearCheck isn't possible, wait some seconds and try again";
L["Error"] = "Error: unable to register GearCheck-Message-Prefix";
L["loadingGC"] = GearCheckVersion.. " is loading";
L["report"] = "Report";
L["Report"] = "GearCheck-Report";
L["R"] = "R";
L["oor"] = " is out of Range";
L["tooltip"] = "RIL = Real-Item-Level |nBIL = Blizzard-Item-Level |nres. = Resiliance";
L["LDBClick"] = "Click to open "..GearCheckVersion;
L["Help"] = "O = Show Options|nR = Report|n? = Show Help|nX = Close Frame|n|nPerform GearCheck = Performs a GearCheck depending on the selected CheckBox";
L["updateMessage"] = "|cffff0000A new GearCheck-Version is availiable. Please update your GearCheck.|r";
L["advancedOptions"] = "Advanced Options:";
L["enableRecheck"] = "Enable Recheck";
L["NumInspections"] = "Inspects / Unit:";
L["additionalWaittime"] = "Waittime / Inspect:";
L["debugon"] = "|cff7bbef7"..GearCheckVersion..": Debug-Mode activated|r";
L["debugoff"] = "|cff7bbef7"..GearCheckVersion..": Debug-Mode deactivated|r";
if (GetLocale() == "enUS") then
elseif (GetLocale() == "deDE") then
	L["requestGC"] = "GearCheck durchf\195\188hren";
	L["runningGC"] = "Bearbeite GearCheck"
	L["PartyReport"] = "Gruppen-GearCheck "..GearCheckVersionShort..":";
	L["RaidReport"] = "Raid-GearCheck "..GearCheckVersionShort..":";
	L["GuildReport"] = "Gilden-GearCheck "..GearCheckVersionShort..":";
	L["TargetReport"] = "Gear-Check "..GearCheckVersionShort.." von ";
	L["requestinformation"] = "RIL = Real-Item-Level, BIL = Blizzard-Item-Level. Es werden nur Zielpersonen angezeigt, die ebenfalls dieses AddOn verwenden.";	
	L["requestinformation2"] = "RIL = Real-Item-Level, BIL = Blizzard-Item-Level. BIL und Abh. kann nur angezeigt werden, wenn die Zielpersonen ebenfalls dieses AddOn verwenden."
	L["noAddOn"] = " benutzt dieses AddOn nicht. Es werden nur Zielpersonen angezeigt, die sich in Reichweite befinden oder ebenfalls dieses AddOn verwenden.";
	L["noResponse"] = " Antwortet nicht";
	L["Report:"]="Bericht an:";
	L["ChatFrame1"]="ChatFrame1";
	L["/say"]="/sagen";
	L["/yell"]="/schreien";
	L["/party"]="/gruppe";
	L["/raid"]="/schlachtzug";
	L["/guild"]="/gilde";
	L["/whisper:"]="/fl\195\188stern:";
	L["Options:"]="Optionen:";
	L["lockFrames"]="Fenster sperren";
	L["enableMinimapButton"]="Minimap-Button anzeigen";
	L["lockMinimapButton"]="Minimap-Button sperren";
	L["Respond"] = "GC-Anfragen beantworten";		
	L["Check:"] = "\195\156berpr\195\188fe:";
	L["party"] = "Gruppe";
	L["raid"] = "Raid";
	L["guild"] = "Gilde";
	L["target"] = "Ziel: ";
	L["resiliance"] = " Abh.";
	L["resi"] = "Abh.";
	L["Head"] = "# || RIL || BIL || Name (Abh.)";
	L["REALITEMLEVEL"] = "Die durchschnittliche Gegenstandsstufe Eurer momentan angelegten Ausr\195\188stung.";
	L["GCdisabled"] = "Durchf\195\188hrung des GearChecks ist momentan nicht m\195\182glich. In einigen Sekunden erneut probieren.";
	L["Error"] = "Error: GearCheck-Message-Prefix konnte nicht registriert werden";
	L["loadingGC"] = GearCheckVersion.. " wird geladen";
	L["report"] = "Berichten";
	L["Report"] = "GearCheck-Bericht";
	L["R"] = "B";
	L["oor"] = " ist au\195\159er Reichweite";
	L["tooltip"] = "RIL = Real-Item-Level |nBIL = Blizzard-Item-Level |nAbh. = Abh\195\164rtung";
	L["LDBClick"] = "Klicken, um "..GearCheckVersion.." zu \195\182ffnen";
	L["Help"] = "O = Optionen|nB = Berichten|n? = Hilfe|nX = Fenster schlie\195\159en|n|nGearCheck durchf\195\188hren = GearCheck wird durchgef\195\188hrt, abh\195\164ngig davon, welche CheckBox ausgew\195\164hlt ist";
	L["updateMessage"] = "|cffff0000Eine neue GearCheck-Version ist verf\195\188gbar. Bitte GearCheck aktualisieren.|r";
	L["advancedOptions"] = "Erweiterte Optionen:";
	L["enableRecheck"] = "Recheck durchf\195\188hren";
	L["NumInspections"] = "Inspects / Unit:";
	L["additionalWaittime"] = "Wartezeit / Inspect:";
	L["debugon"] = "|cff7bbef7"..GearCheckVersion..": Debug-Modus aktiviert|r";
	L["debugoff"] = "|cff7bbef7"..GearCheckVersion..": Debug-Modus deaktiviert|r";
else
end
--end localization
	
local function GearCheckWaitFrameOnUpdate(self, elapsed)	
	time = time + elapsed;	
	local count = #waitTable;
	local i = 1;
	if (count == 0) then
		GearCheckWaitFrame:Hide();
		time = 0;		
	else
		while(i<=count) do
			local waitRecord = tremove(waitTable,i);
			local d = tremove(waitRecord,1);
			local f = tremove(waitRecord,1);
			local p = tremove(waitRecord,1);
			if(d>elapsed) then
				tinsert(waitTable,i,{d-elapsed,f,p});				
				i = i + 1;
			else
				count = count - 1;
				f(unpack(p));
			end
		end
	end
end

local function GearCheckWait(delay, func, ...)
	if(type(delay)~="number" or type(func)~="function") then
		return false;
	end
	if(not(GearCheckWaitFrame:IsShown())) then
		GearCheckWaitFrame:Show();
	end
	tinsert(waitTable,{delay,func,{...}});
	return true;
end

local function GearChecktobool(arg1)
	if arg1 == 1 or arg1 == true then
		return true;
	else
		return false;
	end
end

local function GearCheckSort(db)	
	local database = {};
	for name, a in pairs(db) do
		local n = #database + 1;		
		local i = 1;
		while i <= n do				
			if i == n then					
				tinsert(database, name);					
			elseif (tonumber(a[1]) > tonumber(db[database[i]][1])) then				
				tinsert(database, i, name);
				i = n;
			elseif(tonumber(a[1]) == tonumber(db[database[i]][1])) then
				if (tonumber(a[2]) > tonumber(db[database[i]][2])) then						
					tinsert(database, i, name);
					i = n;
				elseif (tonumber(a[2]) == tonumber(db[database[i]][2])) then
					if name < database[i] then							
						tinsert(database, i, name);
						i = n;
					end
				end
			end
			i = i + 1;
		end		
	end
	return database
end

local function GearCheckNotifyInspect(unit)	
	_G.NotifyInspect(unit);	
end

local function GearCheckClearInspectPlayer()
	ClearInspectPlayer();
end

local function GearCheckCreateSChild(j)
	local x = #GearCheckFrameSChildContentTable;
	for i = x + 1, j + 1 do
		local GearCheckFrameSChildContent = {};
		
		GearCheckFrameSChildContent[0] = CreateFrame("FRAME", "GearCheckFrameSChildContent[0]", GearCheckFrameSChild);		
		GearCheckFrameSChildContent[0]:SetWidth(GearCheckFrameSChild:GetWidth() - 20);
		GearCheckFrameSChildContent[0]:SetHeight(15);
		GearCheckFrameSChildContent[0]:SetScript("OnEnter", function(self)
												self:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background"});
												self:SetBackdropColor(0.8,0.8,0.8,0.9);
												end);
		GearCheckFrameSChildContent[0]:SetScript("OnLeave", function(self)
												self:SetBackdrop(nil);
												end);
		GearCheckFrameSChildContent[0]:SetPoint("TOPLEFT", GearCheckFrameSChildContentTable[i-1][0], "BOTTOMLEFT");
		GearCheckFrameSChildContent[0]:Show();
		
		GearCheckFrameSChildContent[1] = GearCheckFrameSChildContent[0]:CreateFontString(nil, "Artwork", "ChatFontNormal");
		GearCheckFrameSChildContent[1]:SetTextColor(1, 1, 1, 1.0);	
		GearCheckFrameSChildContent[1]:SetPoint("TOPLEFT");
		GearCheckFrameSChildContent[1]:SetWidth(21);
		GearCheckFrameSChildContent[1]:SetJustifyH("RIGHT");
		
		GearCheckFrameSChildContent[2] = GearCheckFrameSChildContent[0]:CreateFontString(nil, "Artwork", "ChatFontNormal");
		GearCheckFrameSChildContent[2]:SetTextColor(1, 1, 1, 1.0);	
		GearCheckFrameSChildContent[2]:SetPoint("TOPLEFT", GearCheckFrameSChildContent[1], "TOPRIGHT");
		GearCheckFrameSChildContent[2]:SetWidth(35);
		GearCheckFrameSChildContent[2]:SetHeight(15);
		GearCheckFrameSChildContent[2]:SetJustifyH("RIGHT");
		
		GearCheckFrameSChildContent[3] = GearCheckFrameSChildContent[0]:CreateFontString(nil, "Artwork", "ChatFontNormal");
		GearCheckFrameSChildContent[3]:SetTextColor(1, 1, 1, 1.0);	
		GearCheckFrameSChildContent[3]:SetPoint("TOPLEFT", GearCheckFrameSChildContent[2], "TOPRIGHT");
		GearCheckFrameSChildContent[3]:SetWidth(35);
		GearCheckFrameSChildContent[3]:SetHeight(15);
		GearCheckFrameSChildContent[3]:SetJustifyH("RIGHT");	
		
		GearCheckFrameSChildContent[4] = GearCheckFrameSChildContent[0]:CreateFontString(nil, "Artwork", "ChatFontNormal");
		GearCheckFrameSChildContent[4]:SetTextColor(1, 1, 1, 1.0);			
		GearCheckFrameSChildContent[4]:SetJustifyH("LEFT");		
		GearCheckFrameSChildContent[4]:SetPoint("TOPLEFT", GearCheckFrameSChildContent[3], "TOPRIGHT", 15, 0);		

		GearCheckFrameSChildContent[0]:Hide();
		
		tinsert(GearCheckFrameSChildContentTable, GearCheckFrameSChildContent);
	end
end

local function GearCheckInitStringTable()	
	local GearCheckFrameSChildContent = {};
	
	GearCheckFrameSChildContent[0] = CreateFrame("FRAME", "GearCheckFrameSChildContent[0]", GearCheckFrameSChild);		
	GearCheckFrameSChildContent[0]:SetWidth(210);
	GearCheckFrameSChildContent[0]:SetHeight(15);
	
	local GearCheckSChildTooltipFrame = CreateFrame("FRAME", "GearCheckSChildTooltipFrame", UIParent);
	GearCheckSChildTooltipFrame:SetWidth(210);
	GearCheckSChildTooltipFrame:SetHeight(52);
	GearCheckSChildTooltipFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	GearCheckSChildTooltipFrame:SetBackdropColor(0.0,0.0,0.0,1);
	GearCheckSChildTooltipFrame:SetPoint("TOPLEFT", GearCheckFrameSChildContent[0], "TOPLEFT", 0, -10);
	GearCheckSChildTooltipFrame:SetFrameStrata("TOOLTIP");
	GearCheckSChildTooltipFrame:SetFrameLevel(GearCheckFrameSChild:GetFrameLevel() + 1);
	GearCheckSChildTooltipFrame:Hide();

	local GearCheckSChildTooltipFrameText = GearCheckSChildTooltipFrame:CreateFontString(nil, "Tooltip", "ChatFontNormal");	
	GearCheckSChildTooltipFrameText:SetTextColor(1.0, 0.8, 0, 0.8);
	GearCheckSChildTooltipFrameText:SetPoint("TOPLEFT", 5, -5);
	GearCheckSChildTooltipFrameText:SetJustifyH("LEFT");
	GearCheckSChildTooltipFrameText:SetText(L["tooltip"]);
	GearCheckSChildTooltipFrameText:Show();
	
	GearCheckFrameSChildContent[0]:SetScript("OnEnter", function()											
											GearCheckSChildTooltipFrame:Show();
											end);
	GearCheckFrameSChildContent[0]:SetScript("OnLeave", function()											
											GearCheckSChildTooltipFrame:Hide();
											end);	
	GearCheckFrameSChildContent[0]:SetPoint("TOPLEFT");
	GearCheckFrameSChildContent[0]:Hide();
	
	GearCheckFrameSChildContent[1] = GearCheckFrameSChildContent[0]:CreateFontString(nil, "Artwork", "ChatFontNormal");
	GearCheckFrameSChildContent[1]:SetTextColor(1.0, 0.8, 0, 0.8);
	GearCheckFrameSChildContent[1]:SetPoint("TOPLEFT");	
	GearCheckFrameSChildContent[1]:SetWidth(21);
	GearCheckFrameSChildContent[1]:SetHeight(15);	
	GearCheckFrameSChildContent[1]:SetText("#");
	GearCheckFrameSChildContent[1]:SetJustifyH("RIGHT");
		
	GearCheckFrameSChildContent[2] = GearCheckFrameSChildContent[0]:CreateFontString(nil, "Artwork", "ChatFontNormal");
	GearCheckFrameSChildContent[2]:SetTextColor(1.0, 0.8, 0, 0.8);
	GearCheckFrameSChildContent[2]:SetPoint("TOPLEFT", GearCheckFrameSChildContent[1], "TOPRIGHT");
	GearCheckFrameSChildContent[2]:SetWidth(35);
	GearCheckFrameSChildContent[2]:SetHeight(15);
	GearCheckFrameSChildContent[2]:SetText("RIL");
	GearCheckFrameSChildContent[2]:SetJustifyH("RIGHT");
		
	GearCheckFrameSChildContent[3] = GearCheckFrameSChildContent[0]:CreateFontString(nil, "Artwork", "ChatFontNormal");
	GearCheckFrameSChildContent[3]:SetTextColor(1.0, 0.8, 0, 0.8);
	GearCheckFrameSChildContent[3]:SetPoint("TOPLEFT", GearCheckFrameSChildContent[2], "TOPRIGHT");
	GearCheckFrameSChildContent[3]:SetWidth(35);
	GearCheckFrameSChildContent[3]:SetHeight(15);
	GearCheckFrameSChildContent[3]:SetText("BIL");
	GearCheckFrameSChildContent[3]:SetJustifyH("RIGHT");
		
	GearCheckFrameSChildContent[4] = GearCheckFrameSChildContent[0]:CreateFontString(nil, "Artwork", "ChatFontNormal");	
	GearCheckFrameSChildContent[4]:SetTextColor(1.0, 0.8, 0, 0.8);
	GearCheckFrameSChildContent[4]:SetPoint("TOPLEFT", GearCheckFrameSChildContent[3], "TOPRIGHT", 15, 0);
	GearCheckFrameSChildContent[4]:SetText("Name ("..L["resi"]..")");
	GearCheckFrameSChildContent[4]:SetJustifyH("LEFT");
		
	tinsert(GearCheckFrameSChildContentTable, GearCheckFrameSChildContent);
end

local function GearCheckHideSChildItem(j)	
	local x = #GearCheckFrameSChildContentTable;
	for i = j, x do		
		GearCheckFrameSChildContentTable[i][2]:SetWidth(35);
		GearCheckFrameSChildContentTable[i][2]:SetJustifyH("RIGHT");		
		GearCheckFrameSChildContentTable[i][0]:Hide();
	end
end

local function GearCheckRefreshSChild()
	GearCheckLastResults = GearCheckCurrentResults;
	local GearCheckSortedDB = GearCheckSort(GearCheckCurrentResults);
	local j = 1;
	GearCheckFrameSChildContentTable[1][0]:Show();
	for i, name in ipairs(GearCheckSortedDB) do
		if (not (tContains(GearCheckCurrentNamesList, name))) then
			tinsert(GearCheckCurrentNamesList, name);			
		end	
		local name3 = name;
		local pos = strfind(name, "-");
		if pos == nil then
			name3 = name3.."-"..GearCheckRealm;
		end
		GearCheckDB[name3] = GearCheckCurrentResults[name];
		--tinsert(GearCheckDB[name3], date("%d.%m.%y %H:%M:%S"));	
		if (i + 1) > #GearCheckFrameSChildContentTable then
			GearCheckCreateSChild((i + 1));
		end
		GearCheckFrameSChildContentTable[i+1][0]:SetScript("OnMouseUp", function()											
											if GearCheckFrameRequestButton:IsEnabled() then
												local mode = "TARGET";
												if GearCheckCheckButtonParty:GetChecked() then
													mode = "PARTY";
												elseif GearCheckCheckButtonRaid:GetChecked() then
													mode = "RAID";
												elseif GearCheckCheckButtonGuild:GetChecked() then
													mode = "GUILD";
												end
												GearCheckReCheck(name, mode);											
											end
										end);
		GearCheckFrameSChildContentTable[i+1][1]:SetText(i..".");
		GearCheckFrameSChildContentTable[i+1][2]:SetWidth(35);
		GearCheckFrameSChildContentTable[i+1][2]:SetJustifyH("RIGHT");
		if GearCheckCurrentResults[name][1] >= 0 then
			if GearCheckCurrentResults[name][2] == -1 then				
				GearCheckFrameSChildContentTable[i+1][2]:SetText(GearCheckCurrentResults[name][1]);
				GearCheckFrameSChildContentTable[i+1][3]:SetText("N/A");
				GearCheckFrameSChildContentTable[i+1][4]:SetText(name.." (N/A)");				
			else				
				GearCheckFrameSChildContentTable[i+1][2]:SetText(GearCheckCurrentResults[name][1]);				
				GearCheckFrameSChildContentTable[i+1][3]:SetText(GearCheckCurrentResults[name][2]);				
				GearCheckFrameSChildContentTable[i+1][4]:SetText(name.." ("..GearCheckCurrentResults[name][3]..")");								
			end
		elseif GearCheckCurrentResults[name][1] == -1 then			
			GearCheckFrameSChildContentTable[i+1][2]:SetWidth(180);
			GearCheckFrameSChildContentTable[i+1][2]:SetJustifyH("LEFT");
			GearCheckFrameSChildContentTable[i+1][2]:SetText("  "..name..L["noResponse"]);			
		elseif GearCheckCurrentResults[name][3] == -2 then			
			GearCheckFrameSChildContentTable[i+1][2]:SetWidth(180);
			GearCheckFrameSChildContentTable[i+1][2]:SetJustifyH("LEFT");
			GearCheckFrameSChildContentTable[i+1][2]:SetText("  "..name..L["oor"]);			
		end
		GearCheckFrameSChildContentTable[i+1][0]:Show();
		j = i + 2;
	end
	GearCheckHideSChildItem(j);
end

local function GearCheckSChildStatus(a)	
	if #GearCheckFrameSChildContentTable < 2 then
		GearCheckCreateSChild(2);
	end
	if a >= 2 then
		GearCheckNumChecked = GearCheckNumChecked + 1;		
		GearCheckFrameSChildContentTable[2][1]:SetText("");
		GearCheckFrameSChildContentTable[2][2]:SetWidth(180);
		GearCheckFrameSChildContentTable[2][2]:SetJustifyH("LEFT");
		GearCheckFrameSChildContentTable[2][2]:SetText(L["runningGC"]..": "..GearCheckNumChecked.."/"..a);
		GearCheckFrameSChildContentTable[2][3]:SetText("");
		GearCheckFrameSChildContentTable[2][4]:SetText("");
		GearCheckFrameSChildContentTable[2][0]:Show();
	else
		GearCheckFrameSChildContentTable[2][1]:SetText("");
		GearCheckFrameSChildContentTable[2][2]:SetWidth(180);
		GearCheckFrameSChildContentTable[2][2]:SetJustifyH("LEFT");
		GearCheckFrameSChildContentTable[2][2]:SetText(L["runningGC"]);
		GearCheckFrameSChildContentTable[2][3]:SetText("");
		GearCheckFrameSChildContentTable[2][4]:SetText("");
		GearCheckFrameSChildContentTable[2][0]:Show();
	end
end

local function GearCheckGetCurrentAverageItemLevel(unit)
	--print(unit);
	local ril = 0;
	local j = 16;
	for i = 1, 18 do 
		if i ~= 4 then 
			local k = GetInventoryItemLink(unit, i);			
			if k then 
				local n, l, _, itemLevel = GetItemInfo(k);
				ril = ril + itemLevel;
				if (i == 17) then
					j = j + 1;
				end				
			end
		end
	end
	ril = ril / j;	
	return ril;
end

local function GearCheckGetResiliance()
	return(GetCombatRating(16));
end

local function GearCheckSendAddonMessageRequest(channel)
	if ((channel == "PARTY") or (channel == "RAID") or (channel == "GUILD")) then		
		SendAddonMessage("GearCheck", "?", channel);
	else
		SendAddonMessage("GearCheck", "?", "WHISPER", channel);
	end
end

local function GearCheckRespond(target)	
	if(not(target == GetUnitName("PLAYER"))) then	
		if GearCheck_Respond then
			SendAddonMessage("GearCheck", "!"..floor(GetAverageItemLevel())..","..floor(GearCheckGetCurrentAverageItemLevel("player"))..","..GearCheckGetResiliance(), "WHISPER", target);
		else		
			SendAddonMessage("GearCheck", "-", "WHISPER", target);
		end
	end
end

local function GearCheckUnitName(target)
local n, r = UnitName(target);
	if (not (UnitIsSameServer(target, "PLAYER"))) then		
		if r then
			n = n.."-"..r;			
		end
	end
	return n;
end

local function GearCheckInspect(target, mode, count)
	local GearCheckAdditionalWaittime2 = GearCheckAdditionalWaittime - 0.05;	
	if not count then
		count = 15
	end
	if ((mode == "PARTY") or (mode == "RAID")) then
		local name = GearCheckUnitName(target);
		if (name and ((GearCheckCurrentResults[name] == nil) or (((GearCheckCurrentResults[name][1] >= 0) and (GearCheckCurrentResults[name][2] == -1)) or (GearCheckCurrentResults[name][1] == -2)))) then
			if (CheckInteractDistance(target, 1)) then
				GearCheckCurrentResults[name] = {tonumber((floor((GearCheckGetCurrentAverageItemLevel(target)), 0))), -1, -1};				
			else
				GearCheckCurrentResults[name] = {-2, -2, -2};
				if count < GearCheckNumInspections then
					time = time + GearCheckAdditionalWaittime2;
				end
			end
			if GearCheckDebug then
				print(name..": "..GearCheckCurrentResults[name][1]);
			end
		else
			if count < GearCheckNumInspections then
				time = time + GearCheckAdditionalWaittime2;
			end
		end
	elseif mode == "GUILD"	then
	else
		if (target and ((GearCheckCurrentResults[target] == nil) or (((GearCheckCurrentResults[target][1] >= 0) and (GearCheckCurrentResults[target][2] == -1)) or (GearCheckCurrentResults[target][1] == -2)))) then
			if (CheckInteractDistance(mode, 1)) then
				GearCheckCurrentResults[target] = {tonumber((floor((GearCheckGetCurrentAverageItemLevel(mode)), 0))), -1, -1};				
			else
				GearCheckCurrentResults[target] = {-2, -2, -2};
				if count < GearCheckNumInspections then
					time = time + GearCheckAdditionalWaittime2;
				end
			end
			if GearCheckDebug then
				print(target..": "..GearCheckCurrentResults[target][1]);
			end
		else
			if count < GearCheckNumInspections then
				time = time + GearCheckAdditionalWaittime2;
			end
		end
	end
end

local function GearCheckReport(message)
	if GearCheckReportTo["ChatFrame1"] then
		print(message);
	end
	if GearCheckReportTo["Say"] then
		SendChatMessage(message, "SAY");
	end
	if GearCheckReportTo["Yell"] then
		SendChatMessage(message, "YELL");
	end
	if GearCheckReportTo["Party"] then
		if GetNumPartyMembers() > 0 then
			SendChatMessage(message, "PARTY");
		elseif GetNumRaidMembers() > 0 then
			SendChatMessage(message, "PARTY");
		end
	end
	if ((GearCheckReportTo["Raid"]) and (GetNumRaidMembers() > 0)) then
		SendChatMessage(message, "RAID");
	end
	if GearCheckReportTo["Guild"] then
		local guild = GetGuildInfo("player");		
		if (not(guild == nil)) then
			SendChatMessage(message, "GUILD");
		end
	end
	if GearCheckReportTo["Whisper"] then
		local h = GearCheckReportFrameWhisperBox:GetText();
		if (not (h == nil)) then
			SendChatMessage(message, "WHISPER", nil, h);
		end
	end
end

local function GearCheckReportData()
	if GearCheckCheckButtonRaid:GetChecked() then
		mode = "RAID";
	elseif GearCheckCheckButtonParty:GetChecked() then
		mode = "PARTY";
	elseif GearCheckCheckButtonGuild:GetChecked() then
		mode = "GUILD";
	end	
	if (not(GearCheckCurrentResults == nil)) then	
		if ((mode == "PARTY") or (mode == "RAID") or (mode == "GUILD")) then
			local GearCheckSortedDB = GearCheckSort(GearCheckCurrentResults);
			if mode == "PARTY" then
				GearCheckReport(L["PartyReport"]);
			elseif mode == "RAID" then
				GearCheckReport(L["RaidReport"]);
			elseif mode == "GUILD" then
				GearCheckReport(L["GuildReport"]);
			end
			GearCheckReport(L["Head"]);
			for i, name in ipairs(GearCheckSortedDB) do			
				if GearCheckCurrentResults[name][1] >= 0 then
					if GearCheckCurrentResults[name][3] == -1 then
						GearCheckReport(i..". || "..GearCheckCurrentResults[name][1].." || N/A || "..name.." (N/A)");						
					else
						GearCheckReport(i..". || "..GearCheckCurrentResults[name][1].." || "..GearCheckCurrentResults[name][2].." || "..name.." ("..GearCheckCurrentResults[name][3]..")");
					end
				elseif GearCheckCurrentResults[name][1] == -1 then
					GearCheckReport(i..". "..name..L["noResponse"]);
				elseif GearCheckCurrentResults[name][1] == -2 then
					GearCheckReport(i..". "..name..L["oor"]);
				end
			end
			if ((mode == "PARTY") or (mode == "RAID")) then
				GearCheckReport(L["requestinformation2"]);		
			elseif mode == "GUILD" then
				GearCheckReport(L["requestinformation"]);
			end
		else
			local name = GearCheckUnitName(mode);
			if (not(GearCheckCurrentResults[name] == nil)) then				
				if GearCheckCurrentResults[name][1] >= 0 then
					GearCheckReport(L["TargetReport"]..name..":");						
					if GearCheckCurrentResults[name][3] == -1 then
						GearCheckReport("RIL: "..GearCheckCurrentResults[name][1]);
						GearCheckReport("BIL: N/A");
						GearCheckReport(L["resi"]..": N/A");						
					else
						GearCheckReport("RIL: "..GearCheckCurrentResults[name][1]);
						GearCheckReport("BIL: "..GearCheckCurrentResults[name][2]);
						GearCheckReport(L["resi"]..": "..GearCheckCurrentResults[name][3]);
					end
					GearCheckReport(L["requestinformation2"]);
				elseif GearCheckCurrentResults[name][1] == -1 then
					GearCheckReport(i..". "..name..L["noResponse"]);
				elseif GearCheckCurrentResults[name][1] == -2 then
					GearCheckReport(i..". "..name..L["oor"]);
				end
			end
		end
	end
end

local function GearCheckFrameButtonsEnable()
	GearCheckCheckButtonParty:Enable();
	GearCheckCheckButtonRaid:Enable();
	GearCheckCheckButtonGuild:Enable();
	GearCheckOptionParty:SetTextColor(1, 1, 1, 1);
	GearCheckOptionRaid:SetTextColor(1, 1, 1, 1);
	GearCheckOptionGuild:SetTextColor(1, 1, 1, 1);
	GearCheckFrameRequestButton:SetText(L["requestGC"]);
	GearCheckFrameRequestButton:Enable();
	GearCheckReportFrameReportButton:Enable();		
	if (GearCheckFrameSChildContentTable[1][0]:IsShown()) then
		GearCheckFrameReportButton:Enable();
	end
end

local function GearCheckFrameButtonsDisable()
	GearCheckCheckButtonParty:Disable();
	GearCheckCheckButtonRaid:Disable();
	GearCheckCheckButtonGuild:Disable();
	GearCheckOptionParty:SetTextColor(0.7, 0.7, 0.7, 1);
	GearCheckOptionRaid:SetTextColor(0.7, 0.7, 0.7, 1);
	GearCheckOptionGuild:SetTextColor(0.7, 0.7, 0.7, 1);
	GearCheckFrameRequestButton:SetText(L["runningGC"]);
	GearCheckFrameRequestButton:Disable();
	wipe(GearCheckCurrentResults);
	wipe(GearCheckLastResults);
	wipe(GearCheckCurrentNamesList);
	GearCheckNumChecked = 0;
	GearCheckHideSChildItem(1);
	GearCheckReportFrameReportButton:Disable();
	GearCheckFrameReportButton:Disable();
	GearCheckReportFrame:Hide();
end

local function GearCheckFrameButtonsDisable2()	
	GearCheckCheckButtonParty:Disable();
	GearCheckCheckButtonRaid:Disable();
	GearCheckCheckButtonGuild:Disable();
	GearCheckOptionParty:SetTextColor(0.7, 0.7, 0.7, 1);
	GearCheckOptionRaid:SetTextColor(0.7, 0.7, 0.7, 1);
	GearCheckOptionGuild:SetTextColor(0.7, 0.7, 0.7, 1);
	GearCheckFrameRequestButton:Disable();
	GearCheckReportFrameReportButton:Disable();
	GearCheckFrameReportButton:Disable();
	GearCheckReportFrame:Hide();
end

local function GearCheckReportFrameReportButtonEnable()
	GearCheckReportFrameReportButton:Enable();
end

local function GearCheckGetUnit(name, mode)
	if ((mode == "PARTY") or (mode == "RAID")) then
		local j = 0;
		local x = "";
		if ((mode == "RAID") and (GetNumRaidMembers() > 0)) then
			j = GetNumRaidMembers();		
		elseif ((mode == "PARTY") and (GetNumPartyMembers() > 0)) then
			j = GetNumPartyMembers();
		end
		for i = 1, j do
			if ((mode == "RAID") and (GetNumRaidMembers() > 0)) then
				x = "raid"..i;
			elseif ((mode == "PARTY") and (GetNumPartyMembers() > 0)) then
				x = "party"..i;
			end
			if name == GearCheckUnitName(x) then 
				return x;
			end
		end
		return nil;
	elseif mode == "TARGET" then
		if name == GearCheckUnitName(mode) then 
			return mode;
		else
			return nil;
		end
	else
		return nil;
	end
end

function GearCheckReCheck(name, mode, arg)	
	if not arg then
		arg = 0;
	end	
	waittime = 0;
	if name then
		if tContains(GearCheckCurrentNamesList, name) then		
			if name == GetUnitName("PLAYER") then
				if GearCheck_Respond then
					GearCheckCurrentResults[name] = {tonumber((floor((GearCheckGetCurrentAverageItemLevel("PLAYER")), 0))), tonumber(floor(GetAverageItemLevel())), tonumber(GearCheckGetResiliance())};
				else
					GearCheckCurrentResults[name] = {-1, -1, -1};
				end
				if arg == 0 then
					GearCheckRefreshSChild();
				end
			else
				if mode == "GUILD" then
					GearCheckSendAddonMessageRequest(name);					
					if arg == 0 then
						GearCheckFrameButtonsDisable2();
						waittime = waittime + 1;
						GearCheckWait(waittime, GearCheckRefreshSChild);
						waittime = waittime + 1;
						GearCheckWait(waittime, GearCheckFrameButtonsEnable);						
					end
				else
					local x = GearCheckGetUnit(name, mode);				
					if (x and UnitIsConnected(x)) then				
						if arg == 0 then
							GearCheckFrameButtonsDisable2();		
						elseif arg == 1 then
							--GearCheckSChildStatus(-3);
						end					
						GearCheckSendAddonMessageRequest(name);
						waittime = waittime + 1;
						if CheckInteractDistance(x, 1) then
							GearCheckWait(waittime, GearCheckNotifyInspect, x);
							if mode == "TARGET" then
								x = GearCheckUnitName(mode);
							end
							GearCheckWait(waittime, GearCheckInspect, x, mode, 1);
							for count = 2, GearCheckNumInspections do
								waittime = waittime + GearCheckAdditionalWaittime; --0.3
								GearCheckWait(waittime, GearCheckInspect, x, mode, count);
							end
							waittime = waittime + 0.1; --1.3
							GearCheckWait(waittime, GearCheckClearInspectPlayer);
							waittime = waittime + 0.2; --1.5
						end
						if arg == 0 then
							GearCheckWait(waittime, GearCheckRefreshSChild);
							waittime = waittime + 1;
							GearCheckWait(waittime, GearCheckFrameButtonsEnable);						
						end
					end
				end
			end
		else
			if arg == 1 then
				time = time + 1.9;						
			end
		end
	end
end

local function GearCheckCollectData2(mode)
	waittime = 1;
	GearCheckWait(waittime, GearCheckRefreshSChild);
	if GearCheckOptionsCheckButtonEnableRecheck:GetChecked() then	
		for name, a in pairs(GearCheckCurrentResults) do
			if a then
				if ((a[2] == -2) or (a[1] == 0)) then				
					GearCheckWait(waittime, GearCheckReCheck, name, mode, 1);
					waittime = waittime + 2;
				end
			end
		end
		GearCheckWait(waittime, GearCheckRefreshSChild);
	end
	waittime = waittime + 1;
	GearCheckWait(waittime, GearCheckFrameButtonsEnable);
end
	
local function GearCheckCollectData(mode)
	local name = GetUnitName("PLAYER");
	local t = 0.4;	
	if (((mode == "RAID") and (GetNumRaidMembers() > 0)) or ((mode == "PARTY") and (GetNumPartyMembers() > 0))) then
		if GearCheck_Respond then			
			GearCheckCurrentResults[name] = {tonumber((floor((GearCheckGetCurrentAverageItemLevel("PLAYER")), 0))), tonumber(floor(GetAverageItemLevel())), tonumber(GearCheckGetResiliance())};
		else
			GearCheckCurrentResults[name] = {-1, -1, -1};
		end		
		local j = 0;
		if ((mode == "RAID") and (GetNumRaidMembers() > 0)) then
			j = GetNumRaidMembers();
		elseif ((mode == "PARTY") and (GetNumPartyMembers() > 0)) then
			j = GetNumPartyMembers() + 1;
		end
		if (not (tContains(GearCheckCurrentNamesList, name))) then
			tinsert(GearCheckCurrentNamesList, name);
			GearCheckWait(waittime, GearCheckSChildStatus, j);
		end
		for i = 1, j do
			if ((i % 5) == 0) then
				if i < GetNumRaidMembers() then
					t = 4;
				end
			elseif i > 10 then
				if i > 20 then
					t = 1.2
				else
					t = 0.8;
				end
			else
				t = 0.4;
			end
			local x = "";
			if ((mode == "RAID") and (GetNumRaidMembers() > 0)) then
				x = "raid"..i;
			elseif ((mode == "PARTY") and (GetNumPartyMembers() > 0)) then
				x = "party"..i;
			end
			name = GearCheckUnitName(x);
			if (name and ((GearCheckCurrentResults[name] == nil) or (GearCheckCurrentResults[name][1] == -2))) then
				if (CheckInteractDistance(x, 1)) then
					GearCheckWait(waittime, GearCheckNotifyInspect, x);
					GearCheckWait(waittime, GearCheckInspect, x, mode, 1);
					for count = 2, GearCheckNumInspections do
						waittime = waittime + GearCheckAdditionalWaittime;
						GearCheckWait(waittime, GearCheckInspect, x, mode, count);
					end
					waittime = waittime + 0.1;					
					GearCheckWait(waittime, GearCheckClearInspectPlayer);
				else
					GearCheckCurrentResults[name] = {-2, -2, -2};
					t = 0;
				end
				if (not (tContains(GearCheckCurrentNamesList, name))) then
					tinsert(GearCheckCurrentNamesList, name);
					GearCheckWait(waittime, GearCheckSChildStatus, j);
				end
				waittime = waittime + t;				
			end			
		end
	elseif (mode == "GUILD") then
		GearCheckSChildStatus(-1);
		waittime = 3;
		if GearCheck_Respond then			
			GearCheckCurrentResults[name] = {tonumber((floor((GearCheckGetCurrentAverageItemLevel("PLAYER")), 0))), tonumber(floor(GetAverageItemLevel())), tonumber(GearCheckGetResiliance())};		
		else
			GearCheckCurrentResults[name] = {-1, -1, -1};
		end
	else
		GearCheckSChildStatus(-1);
		name = GearCheckUnitName(mode);
		if (name and ((GearCheckCurrentResults[name] == nil) or (GearCheckCurrentResults[name][1] == -2))) then
			if (CheckInteractDistance(mode, 1)) then
				GearCheckWait(waittime, GearCheckNotifyInspect, mode);												
				GearCheckWait(waittime, GearCheckInspect, name, mode, 1);
				for count = 2, GearCheckNumInspections do
					waittime = waittime + GearCheckAdditionalWaittime;
					GearCheckWait(waittime, GearCheckInspect, name, mode, count);
				end
				waittime = waittime + 0.1;
				GearCheckWait(waittime, GearCheckClearInspectPlayer);
				waittime = waittime + 0.2;
			else
				GearCheckCurrentResults[name] = {-2, -2, -2};				
			end
			if (not (tContains(GearCheckCurrentNamesList, name))) then
				tinsert(GearCheckCurrentNamesList, name);
				GearCheckWait(waittime, GearCheckSChildStatus, -1);
			end		
		end
	end
	GearCheckWait(waittime, GearCheckCollectData2, mode);	
end

local function GearCheckRequest(channel)
	if GearCheckFrameRequestButton:IsEnabled() then
		waittime = 0;
		local guild = GetGuildInfo("PLAYER");
		if ((channel == "PARTY") and (GetNumPartyMembers() > 0)) then			
			GearCheckFrameButtonsDisable();
			GearCheckSChildStatus(-1);
			GearCheckSendAddonMessageRequest(channel);
			GearCheckWait(1.5, GearCheckCollectData, channel);
		elseif ((channel == "RAID") and (GetNumRaidMembers() > 0)) then			
			GearCheckFrameButtonsDisable();
			GearCheckSChildStatus(-1);
			GearCheckSendAddonMessageRequest(channel);
			GearCheckWait(1.5, GearCheckCollectData, channel);
		elseif ((channel == "GUILD") and (not(guild == nil))) then
			GearCheckFrameButtonsDisable();
			GearCheckSChildStatus(-1);
			GearCheckSendAddonMessageRequest(channel);
			GearCheckWait(1.5, GearCheckSendAddonMessageRequest, channel);
			GearCheckCollectData(channel);
		elseif ((not(channel == "PARTY")) and (not(channel == "RAID")) and (not(channel == "GUILD"))) then						
			local name = GearCheckUnitName(channel);			
			GearCheckFrameButtonsDisable();
			GearCheckSChildStatus(-1);
			GearCheckSendAddonMessageRequest(name);
			GearCheckWait(1.5, GearCheckCollectData, channel);
		end
	else
		print(L["GCdisabled"]);
	end
end

local function GearCheckOnEvent(event, arg1, arg2, arg3, arg4)
	if event == "CHAT_MSG_ADDON" and arg1 == "GearCheck" then
		if GearCheckDebug then
			print(arg1.." "..arg2.." "..arg3.." "..arg4);
		end
		--[[
		arg1=prefix 
		arg2=message 
		arg3=distribution type ("PARTY", "RAID", "GUILD", "BATTLEGROUND" or "WHISPER") 
		arg4=sender
		]]--
		if (not(arg4 == GetUnitName("PLAYER"))) then
			local e = string.sub(arg2, 1, 1);
			if e == "!" then
				arg2 = string.sub(arg2, 2);
				local hs, he = string.find(arg2, ",");
				local bil = string.sub(arg2, 0, hs-1);
				arg2 = string.sub(arg2, he+1);
				hs, he = string.find(arg2, ",");
				local ril = string.sub(arg2, 0, hs-1);
				arg2 = string.sub(arg2, he+1);
				local resiliance = tonumber(arg2);					
				GearCheckCurrentResults[arg4] = {tonumber(ril), tonumber(bil), tonumber(resiliance)};
				if (not (tContains(GearCheckCurrentNamesList, arg4))) then
					tinsert(GearCheckCurrentNamesList, arg4);
					if GearCheckCheckButtonParty:GetChecked() then
						GearCheckSChildStatus(GetNumPartyMembers() + 1);
					elseif GearCheckCheckButtonRaid:GetChecked() then
						GearCheckSChildStatus(GetNumRaidMembers());
					elseif GearCheckCheckButtonGuild:GetChecked() then
						GearCheckSChildStatus(-1);
					else
						GearCheckSChildStatus(-2);
					end
				end
			elseif e == "-" then
				GearCheckCurrentResults[arg4] = {-1, -1, -1};				
				if (not (tContains(GearCheckCurrentNamesList, arg4))) then
					tinsert(GearCheckCurrentNamesList, arg4);
					if GearCheckCheckButtonParty:GetChecked() then
						GearCheckSChildStatus(GetNumPartyMembers() + 1);
					elseif GearCheckCheckButtonRaid:GetChecked() then
						GearCheckSChildStatus(GetNumRaidMembers());
					elseif GearCheckCheckButtonGuild:GetChecked() then
						GearCheckSChildStatus(-1);
					else
						GearCheckSChildStatus(-2);
					end
				end
			elseif e == "?" then
				GearCheckRespond(arg4);
			elseif e == "#" then
				if string.find(arg2, " ") then					
				else
					arg2 = string.sub(arg2, 2);					
					if arg2 == "ver?" then
						if arg3 == "WHISPER" then
							SendAddonMessage("GearCheck", "#"..GearCheckVersionNumber, arg3, arg4);
						else
							SendAddonMessage("GearCheck", "#"..GearCheckVersionNumber, arg3);
						end
					else
						arg2 = tonumber(arg2);
						if arg2 then
							if arg2 > tonumber(GearCheckVersionNumber) then
								if showUpdateMessage then
									showUpdateMessage = false
									print(L["updateMessage"]);
								end
							elseif arg2 < tonumber(GearCheckVersionNumber) then
								local guild = GetGuildInfo("PLAYER");
								local wt = 0;
								if guild then
									SendAddonMessage("GearCheck", "#ver?", "GUILD");
									wt = 3;			
								end
								if GetNumRaidMembers() > 0 then				
									GearCheckWait(wt, SendAddonMessage, "GearCheck", "#ver?", "RAID");
								elseif GetNumPartyMembers() > 0 then				
									GearCheckWait(wt, SendAddonMessage, "GearCheck", "#ver?", "PARTY");
								end
							end
						end
					end					
				end
			end
		end
	elseif event == "PARTY_MEMBERS_CHANGED" then
		if GearCheckPlayerStatus == 0 then
			if GetNumRaidMembers() > 0 then
				GearCheckPlayerStatus = 2;
				SendAddonMessage("GearCheck", "#"..GearCheckVersionNumber, "RAID");
			elseif GetNumPartyMembers() > 0 then
				GearCheckPlayerStatus = 1;
				SendAddonMessage("GearCheck", "#"..GearCheckVersionNumber, "PARTY");
			else
				GearCheckPlayerStatus = 0;
			end
		else
			if GetNumRaidMembers() > 0 then
				GearCheckPlayerStatus = 2;				
			elseif GetNumPartyMembers() > 0 then
				GearCheckPlayerStatus = 1;				
			else
				GearCheckPlayerStatus = 0;
			end
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		if not RegisterAddonMessagePrefix("GearCheck") then
			print(L["Error"]);
		else
			local guild = GetGuildInfo("PLAYER");
			if guild then				
				SendAddonMessage("GearCheck", "#"..GearCheckVersionNumber, "GUILD");
			end
			if GetNumPartyMembers() > 0 then				
				SendAddonMessage("GearCheck", "#"..GearCheckVersionNumber, "PARTY");
			end
			if GetNumRaidMembers() > 0 then				
				SendAddonMessage("GearCheck", "#"..GearCheckVersionNumber, "RAID");
			end
		end
		GearCheckFrameButtonsDisable2();
		waittime = 8;
		GearCheckWait(waittime, GearCheckFrameButtonsEnable);
	elseif event == "ADDON_LOADED" and arg1 == "GearCheck" then	
		if GearCheckReportTo == nil then
			GearCheckReportTo = {};
			GearCheckReportTo["ChatFrame1"]=true;
			GearCheckReportTo["Say"]=false;
			GearCheckReportTo["Yell"]=false;
			GearCheckReportTo["Party"]=false;
			GearCheckReportTo["Raid"]=false;
			GearCheckReportTo["Guild"]=false;
			GearCheckReportTo["Whisper"]=false;
		end
		if GearCheck_LockFrames == nil then
			GearCheck_LockFrames = false;
		end
		if GearCheck_Respond == nil then
			GearCheck_Respond = true;
		end
		if GearCheck_LockMinimapButton == nil then
			GearCheck_LockMinimapButton = false;
		end
		if GearCheck_Frame == nil then
			GearCheck_Frame = {};
			GearCheck_Frame["width"] = 250;
			GearCheck_Frame["height"] = 200;
			GearCheck_Frame["point"] = "CENTER";
			GearCheck_Frame["x"] = 0;
			GearCheck_Frame["y"] = 0;
		end
		if GearCheck_MinimapButtonPosition == nil then
			GearCheck_MinimapButtonPosition = {};
			GearCheck_MinimapButtonPosition["point"] = "TOP";
			GearCheck_MinimapButtonPosition["x"] = 0;
			GearCheck_MinimapButtonPosition["y"] = 0;
		end
		if GearCheck_EnableMinimapButton == nil then
			GearCheck_EnableMinimapButton = true;
		end
		if GearCheck_LockShowLootFrame == nil then
			GearCheck_LockShowLootFrame = false;
		end
		if GearCheckOption == nil then
			GearCheckOption = {};
			GearCheckOption["Party"] = true;
			GearCheckOption["Raid"] = false
			GearCheckOption["Guild"] = false;
		end
		if GearCheckWhisperBox == nil then
			GearCheckWhisperBox = "";
		end
		if GearCheckTargetBox == nil then
			GearCheckTargetBox = "";
		end
		if GearCheckDB == nil then
			GearCheckDB = {};
		end
		if GearCheckLastResults == nil then
			GearCheckLastResults = {};
		end
		if GearCheck_EnableRecheck == nil then
			GearCheck_EnableRecheck = true;		
		end
		if GearCheckNumInspections == nil then
			GearCheckNumInspections = GearCheckDefaultNumInspections;
		end
		if GearCheckAdditionalWaittime == nil then
			GearCheckAdditionalWaittime = GearCheckDefaultAdditionalWaittime;
		end
		
		GearCheckReportFrameWhisperBox:SetText(GearCheckWhisperBox);		
		
		GearCheckReportFrameCheckButtonChatFrame:SetChecked(GearCheckReportTo["ChatFrame1"]);
		GearCheckReportFrameCheckButtonSay:SetChecked(GearCheckReportTo["Say"]);
		GearCheckReportFrameCheckButtonYell:SetChecked(GearCheckReportTo["Yell"]);
		GearCheckReportFrameCheckButtonParty:SetChecked(GearCheckReportTo["Party"]);
		GearCheckReportFrameCheckButtonRaid:SetChecked(GearCheckReportTo["Raid"]);
		GearCheckReportFrameCheckButtonGuild:SetChecked(GearCheckReportTo["Guild"]);
		GearCheckReportFrameCheckButtonWhisper:SetChecked(GearCheckReportTo["Whisper"]);
		
		GearCheckCheckButtonParty:SetChecked(GearCheckOption["Party"]);
		GearCheckCheckButtonRaid:SetChecked(GearCheckOption["Raid"]);
		GearCheckCheckButtonGuild:SetChecked(GearCheckOption["Guild"]);
		
		GearCheckOptionsCheckButtonRespond:SetChecked(GearCheck_Respond);
		GearCheckOptionsCheckButtonLockFrames:SetChecked(GearCheck_LockFrames);
		GearCheckOptionsCheckButtonEnableMinimapButton:SetChecked(GearCheck_EnableMinimapButton);
		GearCheckOptionsCheckButtonLockMinimapButton:SetChecked(GearCheck_LockMinimapButton);
		
		GearCheckOptionsCheckButtonEnableRecheck:SetChecked(GearCheck_EnableRecheck);		
		GearCheckOptionsNumInspectionsBox:SetText(GearCheckNumInspections);
		GearCheckOptionsAdditionalWaittimeBox:SetText(GearCheckAdditionalWaittime);
		
		GearCheckFrame:SetWidth(GearCheck_Frame["width"]);
		GearCheckFrame:SetHeight(GearCheck_Frame["height"]);
		GearCheckFrame:SetPoint(GearCheck_Frame["point"], GearCheck_Frame["x"], GearCheck_Frame["y"]);
		
		if not GearCheck_LockFrames then		
			GearCheckTopFrame:RegisterForDrag("LeftButton");			
		end				
		GearCheckMinimapButton:SetPoint(GearCheck_MinimapButtonPosition["point"], Minimap, GearCheck_MinimapButtonPosition["x"], GearCheck_MinimapButtonPosition["y"]);
		if GearCheck_EnableMinimapButton then
			GearCheckMinimapButton:Show();
		else
			GearCheckMinimapButton:Hide();
		end	
		if not GearCheck_LockMinimapButton then		
			GearCheckMinimapButton:RegisterForDrag("LeftButton");			
		end
		if GetNumRaidMembers() > 0 then
			GearCheckPlayerStatus = 2;
		elseif GetNumPartyMembers() > 0 then
			GearCheckPlayerStatus = 1;
		else
			GearCheckPlayerStatus = 0;
		end
		GearCheckInitStringTable();		
		GearCheckCurrentResults = GearCheckLastResults;			
		GearCheckRefreshSChild();
	end
end

local function GearCheckToggle()
	if GearCheckFrame:IsShown() then
		GearCheckFrame:Hide();
		GearCheckOptionsFrame:Hide();
	elseif not GearCheckFrame:IsShown() then
		GearCheckFrame:Show();
	end
end

SlashCmdList["GC"] = function(args)
	if args == "toggle" then
		GearCheckToggle();
	elseif (GearCheckDebug and ((args == "version") or (args == "ver") or (args == "ver?"))) then
		local guild = GetGuildInfo("PLAYER");
		local wt = 0;
		if guild then
			SendAddonMessage("GearCheck", "#ver?", "GUILD");
			wt = 3;			
		end
		if GetNumRaidMembers() > 0 then				
			GearCheckWait(wt, SendAddonMessage, "GearCheck", "#ver?", "RAID");
		elseif GetNumPartyMembers() > 0 then				
			GearCheckWait(wt, SendAddonMessage, "GearCheck", "#ver?", "PARTY");
		end		
	elseif args == "debug" then
		GearCheckDebug = not GearCheckDebug;
		if GearCheckDebug then
			print(L["debugon"]);
		else
			print(L["debugoff"]);
		end
	end
end

--LDB
local ldb = LibStub:GetLibrary("LibDataBroker-1.1");
local dataobj = ldb:GetDataObjectByName("GearCheck") or ldb:NewDataObject("GearCheck", {
	type = "data source", icon = [[Interface\AddOns\GearCheck\GearCheckLDBIcon]], text = "GearCheck",
	OnClick = function() GearCheckToggle() end,
	OnTooltipShow = function(tip)
		tip:AddLine(L["LDBClick"]);
	end,
})
--end LDB

--begin UI
UnitPopupButtons["GearCheck"]={text = "|cffff0000GearCheck|r", dist = 0};
tinsert(UnitPopupMenus["RAID_PLAYER"], 1, "GearCheck");
tinsert(UnitPopupMenus["PARTY"], 1, "GearCheck");
tinsert(UnitPopupMenus["PLAYER"], 1, "GearCheck");
hooksecurefunc("UnitPopup_OnClick", function(this)
	local dropdownFrame = UIDROPDOWNMENU_INIT_MENU
	local button = this.value
	local target = dropdownFrame.unit;	
	if button == "GearCheck" then
		if UnitIsConnected(target) then
			GearCheckCheckButtonParty:SetChecked(false);
			GearCheckOption["Party"] = false;
			GearCheckCheckButtonRaid:SetChecked(false);
			GearCheckOption["Raid"] = false
			GearCheckCheckButtonGuild:SetChecked(false);
			GearCheckOption["Guild"] = false;
			GearCheckRequest(target);
			if not GearCheckFrame:IsShown() then
				GearCheckFrame:Show();
			end
		end
	end	
end);

GameTooltip:HookScript("OnShow", function(self)
	GameTooltipOnShow = GameTooltipOnShow * -1;
	local a, b = self:GetUnit()
	if GameTooltipOnShow == 1 then	
		if ((not (a == nil)) and (UnitIsPlayer(b))) then
			local name, r = UnitName(b);
			if r then
				name = name.."-"..r;
			else
				name = name.."-"..GearCheckRealm;
			end
			if (not (GearCheckDB[name] == nil)) then			
				if GearCheckDB[name][1] > 0 then
					GameTooltip:AddLine(" ");
					GameTooltip:AddLine("RIL: "..GearCheckDB[name][1],1 ,1 ,1);
					if GearCheckDB[name][2] > 0 then
						GameTooltip:AddLine("BIL: "..GearCheckDB[name][2],1 ,1 ,1);				
					end
					if GearCheckDB[name][3] > 0 then
						GameTooltip:AddLine(L["resi"]..": "..GearCheckDB[name][3],1 ,1 ,1);				
					end
				end	
			end
		end
	end	
end);

local GearCheckWaitFrame = CreateFrame("Frame","GearCheckWaitFrame", UIParent);
GearCheckWaitFrame:SetScript("OnUpdate", function(self,elapsed) GearCheckWaitFrameOnUpdate(self, elapsed); end);

local GearCheckMinimapButton = CreateFrame("BUTTON", "GearCheckMinimapButton", Minimap);
GearCheckMinimapButton:SetWidth(31);
GearCheckMinimapButton:SetHeight(31);
GearCheckMinimapButton:SetFrameStrata("LOW");
GearCheckMinimapButton:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight");
GearCheckMinimapButton:SetPoint("RIGHT", Minimap, "LEFT");
GearCheckMinimapButtonIcon = GearCheckMinimapButton:CreateTexture(nil, "BACKGROUND");
GearCheckMinimapButtonIcon:SetTexture("Interface\\AddOns\\GearCheck\\GearCheckIcon");
GearCheckMinimapButtonIcon:SetPoint("TOPLEFT", 6, -6);
GearCheckMinimapButtonIcon:SetPoint("BOTTOMRIGHT", -6, 6);
GearCheckMinimapButtonOverlay = GearCheckMinimapButton:CreateTexture(nil, "OVERLAY");
GearCheckMinimapButtonOverlay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder");
GearCheckMinimapButtonOverlay:SetWidth(53);
GearCheckMinimapButtonOverlay:SetHeight(53);
GearCheckMinimapButtonOverlay:SetPoint("TOPLEFT");
GearCheckMinimapButton:SetMovable(true);
GearCheckMinimapButton:EnableMouse(true);
GearCheckMinimapButton:SetScript("OnDragStart", function() GearCheckMinimapButton:StartMoving() end);
GearCheckMinimapButton:SetScript("OnDragStop", function()
													GearCheckMinimapButton:StopMovingOrSizing();
													local point, relativeTo, relativePoint, x, y = GearCheckMinimapButton:GetPoint();
													GearCheck_MinimapButtonPosition["point"] = point;													
													GearCheck_MinimapButtonPosition["x"] = x;
													GearCheck_MinimapButtonPosition["y"] = y;
												 end);
GearCheckMinimapButton:SetScript("OnClick", function()
												GearCheckToggle();												
											end);										
GearCheckMinimapButton:Hide();

local GearCheckFrame = CreateFrame("FRAME", "GearCheckFrame", UIParent);
GearCheckFrame:SetFrameStrata("TOOLTIP"); 
GearCheckFrame:RegisterEvent("ADDON_LOADED");
GearCheckFrame:RegisterEvent("CHAT_MSG_ADDON");
GearCheckFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
GearCheckFrame:RegisterEvent("PARTY_MEMBERS_CHANGED");
GearCheckFrame:SetScript("OnEvent", function(self, event, arg1, arg2, arg3, arg4, ...)
										GearCheckOnEvent(event, arg1, arg2, arg3, arg4);
										end);
GearCheckFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GearCheckFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
GearCheckFrame:EnableMouse(true);
GearCheckFrame:SetMovable(true);
GearCheckFrame:SetUserPlaced(true);
GearCheckFrame:SetScript("OnSizeChanged", function()
												GearCheckFrameSChild:SetWidth(GearCheckFrame:GetWidth() - 30);
												GearCheckSFrame:SetWidth(GearCheckFrameSChild:GetWidth() - 18);
												GearCheckSFrame:SetHeight(GearCheckFrame:GetHeight() - 100);
											end);
GearCheckFrame:SetResizable(true);
GearCheckFrame:SetMaxResize(GearCheckMaxWidth, GearCheckMaxHeight);
GearCheckFrame:SetMinResize(250, 200);
GearCheckFrame:Hide();
tinsert(UISpecialFrames, GearCheckFrame:GetName());

local GearCheckSFrame = CreateFrame("SCROLLFRAME", "GearCheckSFrame", GearCheckFrame, "UIPanelScrollFrameTemplate");
local GearCheckFrameSChild = CreateFrame("FRAME", "GearCheckFrameSChild", GearCheckSFrame);
GearCheckSFrame:SetScrollChild(GearCheckFrameSChild);
GearCheckSFrame:SetPoint("TOPLEFT", GearCheckFrame, "TOPLEFT", 10, -25);
GearCheckSFrame:SetWidth(GearCheckFrame:GetWidth() - 48);
GearCheckSFrame:SetHeight(GearCheckFrame:GetHeight() - 100);
GearCheckSFrame:SetHorizontalScroll(0);
GearCheckSFrame:SetVerticalScroll(20);
GearCheckSFrame:EnableMouse(true);
GearCheckSFrame:Show();
GearCheckFrameSChild:SetPoint("TOPLEFT");
GearCheckFrameSChild:SetWidth(GearCheckFrame:GetWidth() - 30);
GearCheckFrameSChild:SetHeight(50);
GearCheckFrameSChild:Show();

local GearCheckTopFrame = CreateFrame("FRAME", "GearCheckTopFrame", GearCheckFrame);
GearCheckTopFrame:SetWidth(120);
GearCheckTopFrame:SetHeight(25);
GearCheckTopFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GearCheckTopFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
GearCheckTopFrame:SetPoint("TOP", 0, 10);
GearCheckTopFrame:EnableMouse(true);
GearCheckTopFrame:SetScript("OnDragStart", function()
											GearCheckFrame:StartMoving();
											GearCheckTopFrame:SetBackdropColor(1.0,1.0,1.0,0.9);
										end);
GearCheckTopFrame:SetScript("OnDragStop", function()
												GearCheckFrame:StopMovingOrSizing();
												GearCheckFrameSChild:SetWidth(GearCheckFrame:GetWidth() - 30);
												GearCheckSFrame:SetWidth(GearCheckFrameSChild:GetWidth() - 18);
												GearCheckSFrame:SetHeight(GearCheckFrame:GetHeight() - 100);
												local point, _, _, x, y = GearCheckFrame:GetPoint();
												GearCheck_Frame["point"] = point;													
												GearCheck_Frame["x"] = x;
												GearCheck_Frame["y"] = y;
												GearCheck_Frame["width"] = GearCheckFrame:GetWidth();
												GearCheck_Frame["height"] = GearCheckFrame:GetHeight();
												if (not MouseIsOver(GearCheckTopFrame)) then
													GearCheckTopFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
												end
											end);
GearCheckTopFrame:SetScript("OnEnter", function()
													GearCheckTopFrame:SetBackdropColor(1.0,1.0,1.0,0.9);
												end);
GearCheckTopFrame:SetScript("OnLeave", function()
													if (not IsMouseButtonDown("LeftButton")) then
														GearCheckTopFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
													end
												end);											
GearCheckTopFrame:Show();

local GearCheckFrameText = GearCheckTopFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckFrameText:SetTextColor(1, 0, 0, 1.0);
GearCheckFrameText:SetText(GearCheckVersion);
GearCheckFrameText:SetPoint("CENTER");

local GearCheckFrameOptions = CreateFrame("BUTTON", nil, GearCheckFrame, "UIPanelButtonTemplate");
GearCheckFrameOptions:SetWidth(15);
GearCheckFrameOptions:SetHeight(15);
GearCheckFrameOptions:SetText("O");
GearCheckFrameOptions:SetPoint("TOPLEFT", 5, -5);
GearCheckFrameOptions:SetScript("OnClick", function()
												if GearCheckOptionsFrame:IsShown() then
													GearCheckOptionsFrame:Hide();													
												elseif not GearCheckOptionsFrame:IsShown() then
													GearCheckOptionsFrame:Show();
												end											
											 end);
GearCheckFrameOptions:SetAlpha(1);
GearCheckFrameOptions:Show();

local GearCheckFrameClose = CreateFrame("BUTTON", nil, GearCheckFrame, "UIPanelButtonTemplate");
GearCheckFrameClose:SetWidth(15);
GearCheckFrameClose:SetHeight(15);
GearCheckFrameClose:SetText("X");
GearCheckFrameClose:SetPoint("TOPRIGHT", -5, -5);
GearCheckFrameClose:SetScript("OnClick", function()
											GearCheckFrame:Hide();
											GearCheckOptionsFrame:Hide();
										   end);
GearCheckFrameClose:SetAlpha(1);
GearCheckFrameClose:Show();

local GearCheckFrameHelp = CreateFrame("BUTTON", nil, GearCheckFrame, "UIPanelButtonTemplate");
GearCheckFrameHelp:SetWidth(15);
GearCheckFrameHelp:SetHeight(15);
GearCheckFrameHelp:SetText("?");
GearCheckFrameHelp:SetPoint("RIGHT", GearCheckFrameClose, "LEFT", -5, 0);
GearCheckFrameHelp:SetScript("OnClick", function()
											if GearCheckHelpFrame:IsShown() then
												GearCheckHelpFrame:Hide();
											else
												GearCheckHelpFrame:Show();
											end
										   end);
GearCheckFrameHelp:SetAlpha(1);
GearCheckFrameHelp:Show();

local GearCheckFrameRequestButton = CreateFrame("BUTTON", "GearCheckFrameRequestButton", GearCheckFrame, "UIPanelButtonTemplate");
GearCheckFrameRequestButton:SetWidth(180);
GearCheckFrameRequestButton:SetHeight(30);
GearCheckFrameRequestButton:SetText(L["requestGC"]);
GearCheckFrameRequestButton:SetPoint("BOTTOM", 0, 10);
GearCheckFrameRequestButton:SetScript("OnClick", function()
													if GearCheckCheckButtonParty:GetChecked() then
														GearCheckRequest("PARTY");														
													elseif GearCheckCheckButtonRaid:GetChecked() then
														GearCheckRequest("RAID");
													elseif GearCheckCheckButtonGuild:GetChecked() then
														GearCheckRequest("GUILD");													
													end
												end);
GearCheckFrameRequestButton:SetAlpha(1);
GearCheckFrameRequestButton:Show();

GearCheckOptionParty = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionParty:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionParty:SetWidth(45);
GearCheckOptionParty:SetHeight(15);
GearCheckOptionParty:SetJustifyH("LEFT");
GearCheckOptionParty:SetText(L["party"]);
GearCheckOptionParty:SetPoint("BOTTOMLEFT", GearCheckFrameRequestButton, "TOPLEFT", 0, 10);

local GearCheckCheckButtonParty = CreateFrame("CHECKBUTTON", "GearCheckCheckButtonParty", GearCheckFrame);
GearCheckCheckButtonParty:SetWidth(15);
GearCheckCheckButtonParty:SetHeight(15);
GearCheckCheckButtonParty:SetPoint("RIGHT", GearCheckOptionParty, "LEFT", 0, 0);
GearCheckCheckButtonParty:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckCheckButtonParty:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckCheckButtonParty:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckCheckButtonParty:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckCheckButtonParty:SetScript("OnClick", function()
													if not GearCheckOption["Party"] then
														GearCheckHideSChildItem(1);
														wipe(GearCheckCurrentResults);
														GearCheckFrameReportButton:Disable()
													end
													GearCheckCheckButtonParty:SetChecked(true);
													GearCheckOption["Party"] = true;
													GearCheckCheckButtonRaid:SetChecked(false);
													GearCheckOption["Raid"] = false
													GearCheckCheckButtonGuild:SetChecked(false);
													GearCheckOption["Guild"] = false;													
												end);
GearCheckCheckButtonParty:Show();

GearCheckOptionRaid = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionRaid:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionRaid:SetWidth(45);
GearCheckOptionRaid:SetHeight(15);
GearCheckOptionRaid:SetJustifyH("LEFT");
GearCheckOptionRaid:SetText(L["raid"]);
GearCheckOptionRaid:SetPoint("BOTTOM", GearCheckFrameRequestButton, "TOP", 0, 10);

local GearCheckCheckButtonRaid = CreateFrame("CHECKBUTTON", "GearCheckCheckButtonRaid", GearCheckFrame);
GearCheckCheckButtonRaid:SetWidth(15);
GearCheckCheckButtonRaid:SetHeight(15);
GearCheckCheckButtonRaid:SetPoint("RIGHT", GearCheckOptionRaid, "LEFT", 0, 0);
GearCheckCheckButtonRaid:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckCheckButtonRaid:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckCheckButtonRaid:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckCheckButtonRaid:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckCheckButtonRaid:SetScript("OnClick", function()
													if not GearCheckOption["Raid"] then
														GearCheckHideSChildItem(1);
														wipe(GearCheckCurrentResults);
														GearCheckFrameReportButton:Disable()
													end
													GearCheckCheckButtonParty:SetChecked(false);
													GearCheckOption["Party"] = false;
													GearCheckCheckButtonRaid:SetChecked(true);
													GearCheckOption["Raid"] = true
													GearCheckCheckButtonGuild:SetChecked(false);
													GearCheckOption["Guild"] = false;													
												end);

GearCheckCheckButtonRaid:Show();

GearCheckOptionGuild = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionGuild:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionGuild:SetWidth(45);
GearCheckOptionGuild:SetHeight(15);
GearCheckOptionGuild:SetJustifyH("LEFT");
GearCheckOptionGuild:SetText(L["guild"]);
GearCheckOptionGuild:SetPoint("BOTTOMRIGHT", GearCheckFrameRequestButton, "TOPRIGHT", 0, 10);

local GearCheckCheckButtonGuild = CreateFrame("CHECKBUTTON", "GearCheckCheckButtonGuild", GearCheckFrame);
GearCheckCheckButtonGuild:SetWidth(15);
GearCheckCheckButtonGuild:SetHeight(15);
GearCheckCheckButtonGuild:SetPoint("RIGHT", GearCheckOptionGuild, "LEFT", 0, 0);
GearCheckCheckButtonGuild:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckCheckButtonGuild:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckCheckButtonGuild:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckCheckButtonGuild:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckCheckButtonGuild:SetScript("OnClick", function()
													if not GearCheckOption["Guild"] then
														GearCheckHideSChildItem(1);
														wipe(GearCheckCurrentResults);
														GearCheckFrameReportButton:Disable()
													end
													GearCheckCheckButtonParty:SetChecked(false);
													GearCheckOption["Party"] = false;
													GearCheckCheckButtonRaid:SetChecked(false);
													GearCheckOption["Raid"] = false
													GearCheckCheckButtonGuild:SetChecked(true);
													GearCheckOption["Guild"] = true;													
												end);

GearCheckCheckButtonGuild:Show();

local GearCheckFrameReportButton = CreateFrame("BUTTON", "GearCheckFrameReportButton", GearCheckFrame, "UIPanelButtonTemplate");
GearCheckFrameReportButton:SetWidth(15);
GearCheckFrameReportButton:SetHeight(15);
GearCheckFrameReportButton:SetText(L["R"]);
GearCheckFrameReportButton:SetPoint("TOPLEFT", GearCheckFrameOptions, "TOPRIGHT", 5, 0);
GearCheckFrameReportButton:SetScript("OnClick", function()
												if GearCheckReportFrame:IsShown() then
													GearCheckReportFrame:Hide();													
												elseif not GearCheckReportFrame:IsShown() then
													GearCheckReportFrame:Show();
												end											
											 end);												
GearCheckFrameReportButton:SetAlpha(1);
GearCheckFrameReportButton:Disable()
GearCheckFrameReportButton:Show();

local GearCheckFrameResize = CreateFrame("BUTTON", "GearCheckFrameResize", GearCheckFrame);
GearCheckFrameResize:SetWidth(16);
GearCheckFrameResize:SetHeight(16);
GearCheckFrameResize:SetPoint("BOTTOMRIGHT", GearCheckFrame, "BOTTOMRIGHT", -2, 2);
GearCheckFrameResize:SetNormalTexture("Interface\\AddOns\\GearCheck\\GearCheckResizeButton");
GearCheckFrameResize:SetHighlightTexture("Interface\\AddOns\\GearCheck\\GearCheckResizeButton");
GearCheckFrameResize:SetScript("OnMouseDown", function()
													GearCheckFrame:StartSizing();
												end);
GearCheckFrameResize:SetScript("OnMouseUp", function()
												GearCheckFrame:StopMovingOrSizing();
												GearCheckFrameSChild:SetWidth(GearCheckFrame:GetWidth() - 30);
												for i = 2, #GearCheckFrameSChildContentTable do
													GearCheckFrameSChildContentTable[i][0]:SetWidth(GearCheckFrameSChild:GetWidth() - 20);
												end
												GearCheckSFrame:SetWidth(GearCheckFrameSChild:GetWidth() - 18);
												GearCheckSFrame:SetHeight(GearCheckFrame:GetHeight() - 100);
												local point, _, _, x, y = GearCheckFrame:GetPoint();
												GearCheck_Frame["point"] = point;													
												GearCheck_Frame["x"] = x;
												GearCheck_Frame["y"] = y;
												GearCheck_Frame["width"] = GearCheckFrame:GetWidth();
												GearCheck_Frame["height"] = GearCheckFrame:GetHeight();
											end);

local GearCheckOptionsFrame = CreateFrame("FRAME", "GearCheckOptionsFrame", UIParent);
GearCheckOptionsFrame:SetFrameStrata("TOOLTIP"); 
GearCheckOptionsFrame:SetWidth(250);
GearCheckOptionsFrame:SetHeight(190);
GearCheckOptionsFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GearCheckOptionsFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
GearCheckOptionsFrame:SetPoint("TOP", GearCheckFrame, "BOTTOM", 0, 0);
tinsert(UISpecialFrames, GearCheckOptionsFrame:GetName());
GearCheckOptionsFrame:Hide();

local GearCheckOptionsText3 = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsText3:SetTextColor(1.0, 0.8, 0, 0.8);
GearCheckOptionsText3:SetWidth(150);
GearCheckOptionsText3:SetJustifyH("LEFT");
GearCheckOptionsText3:SetText(L["Options:"]);
GearCheckOptionsText3:SetPoint("TOPLEFT", 5, -10);

local GearCheckOptionsRespond = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsRespond:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsRespond:SetWidth(175);
GearCheckOptionsRespond:SetHeight(15);
GearCheckOptionsRespond:SetJustifyH("LEFT");
GearCheckOptionsRespond:SetText(L["Respond"]);
GearCheckOptionsRespond:SetPoint("TOPLEFT", GearCheckOptionsText3, "BOTTOMLEFT", 25, -5);

local GearCheckOptionsCheckButtonRespond = CreateFrame("CHECKBUTTON", "GearCheckOptionsCheckButtonRespond", GearCheckOptionsFrame);
GearCheckOptionsCheckButtonRespond:SetWidth(15);
GearCheckOptionsCheckButtonRespond:SetHeight(15);
GearCheckOptionsCheckButtonRespond:SetPoint("RIGHT", GearCheckOptionsRespond, "LEFT", -5, 0);
GearCheckOptionsCheckButtonRespond:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonRespond:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonRespond:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonRespond:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonRespond:SetScript("OnClick", function() 
																GearCheck_Respond = GearChecktobool(GearCheckOptionsCheckButtonRespond:GetChecked());															
															 end);
GearCheckOptionsCheckButtonRespond:Show();


local GearCheckOptionsLockFrames = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsLockFrames:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsLockFrames:SetWidth(175);
GearCheckOptionsLockFrames:SetHeight(15);
GearCheckOptionsLockFrames:SetJustifyH("LEFT");
GearCheckOptionsLockFrames:SetText(L["lockFrames"]);
GearCheckOptionsLockFrames:SetPoint("TOPLEFT", GearCheckOptionsRespond, "BOTTOMLEFT", 0, 0);

local GearCheckOptionsCheckButtonLockFrames = CreateFrame("CHECKBUTTON", "GearCheckOptionsCheckButtonLockFrames", GearCheckOptionsFrame);
GearCheckOptionsCheckButtonLockFrames:SetWidth(15);
GearCheckOptionsCheckButtonLockFrames:SetHeight(15);
GearCheckOptionsCheckButtonLockFrames:SetPoint("RIGHT", GearCheckOptionsLockFrames, "LEFT", -5, 0);
GearCheckOptionsCheckButtonLockFrames:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonLockFrames:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonLockFrames:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonLockFrames:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonLockFrames:SetScript("OnClick", function() 
																GearCheck_LockFrames = GearChecktobool(GearCheckOptionsCheckButtonLockFrames:GetChecked());
																if GearCheckOptionsCheckButtonLockFrames:GetChecked() then
																	GearCheckFrame:RegisterForDrag("");
																elseif not GearCheckOptionsCheckButtonLockFrames:GetChecked() then
																	GearCheckFrame:RegisterForDrag("LeftButton");
																end
															 end);
GearCheckOptionsCheckButtonLockFrames:Show();

local GearCheckOptionsEnableMinimapButton = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsEnableMinimapButton:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsEnableMinimapButton:SetWidth(175);
GearCheckOptionsEnableMinimapButton:SetHeight(15);
GearCheckOptionsEnableMinimapButton:SetJustifyH("LEFT");
GearCheckOptionsEnableMinimapButton:SetText(L["enableMinimapButton"]);
GearCheckOptionsEnableMinimapButton:SetPoint("TOPLEFT", GearCheckOptionsLockFrames, "BOTTOMLEFT", 0, 0);

local GearCheckOptionsCheckButtonEnableMinimapButton = CreateFrame("CHECKBUTTON", "GearCheckOptionsCheckButtonEnableMinimapButton", GearCheckOptionsFrame);
GearCheckOptionsCheckButtonEnableMinimapButton:SetWidth(15);
GearCheckOptionsCheckButtonEnableMinimapButton:SetHeight(15);
GearCheckOptionsCheckButtonEnableMinimapButton:SetPoint("RIGHT", GearCheckOptionsEnableMinimapButton, "LEFT", -5, 0);
GearCheckOptionsCheckButtonEnableMinimapButton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonEnableMinimapButton:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonEnableMinimapButton:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonEnableMinimapButton:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonEnableMinimapButton:SetScript("OnClick", function() 
																		GearCheck_EnableMinimapButton = GearChecktobool(GearCheckOptionsCheckButtonEnableMinimapButton:GetChecked());
																		if GearCheckOptionsCheckButtonEnableMinimapButton:GetChecked() then
																			GearCheckMinimapButton:Show();
																		elseif not GearCheckOptionsCheckButtonEnableMinimapButton:GetChecked() then
																			GearCheckMinimapButton:Hide();
																		end
																	  end);
GearCheckOptionsCheckButtonEnableMinimapButton:Show();

local GearCheckOptionsLockMinimapButton = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsLockMinimapButton:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsLockMinimapButton:SetWidth(175);
GearCheckOptionsLockMinimapButton:SetHeight(15);
GearCheckOptionsLockMinimapButton:SetJustifyH("LEFT");
GearCheckOptionsLockMinimapButton:SetText(L["lockMinimapButton"]);
GearCheckOptionsLockMinimapButton:SetPoint("TOPLEFT", GearCheckOptionsEnableMinimapButton, "BOTTOMLEFT", 0, 0);

local GearCheckOptionsCheckButtonLockMinimapButton = CreateFrame("CHECKBUTTON", "GearCheckOptionsCheckButtonLockMinimapButton", GearCheckOptionsFrame);
GearCheckOptionsCheckButtonLockMinimapButton:SetWidth(15);
GearCheckOptionsCheckButtonLockMinimapButton:SetHeight(15);
GearCheckOptionsCheckButtonLockMinimapButton:SetPoint("RIGHT", GearCheckOptionsLockMinimapButton, "LEFT", -5, 0);
GearCheckOptionsCheckButtonLockMinimapButton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonLockMinimapButton:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonLockMinimapButton:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonLockMinimapButton:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonLockMinimapButton:SetScript("OnClick", function()
																		GearCheck_LockMinimapButton = GearChecktobool(GearCheckOptionsCheckButtonLockMinimapButton:GetChecked());
																		if GearCheckOptionsCheckButtonLockMinimapButton:GetChecked() then
																			GearCheckMinimapButton:RegisterForDrag(""); 
																		elseif not GearCheckOptionsCheckButtonLockMinimapButton:GetChecked() then																			
																			GearCheckMinimapButton:RegisterForDrag("LeftButton");
																		end
																	end);
GearCheckOptionsCheckButtonLockMinimapButton:Show();

local GearCheckOptionsText4 = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsText4:SetTextColor(1.0, 0.8, 0, 0.8);
GearCheckOptionsText4:SetWidth(150);
GearCheckOptionsText4:SetJustifyH("LEFT");
GearCheckOptionsText4:SetText(L["advancedOptions"]);
GearCheckOptionsText4:SetPoint("TOPLEFT", GearCheckOptionsCheckButtonLockMinimapButton, "BOTTOMLEFT", -5, -15);

local GearCheckOptionsEnableRecheck = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsEnableRecheck:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsEnableRecheck:SetWidth(150);
GearCheckOptionsEnableRecheck:SetJustifyH("LEFT");
GearCheckOptionsEnableRecheck:SetText(L["enableRecheck"]);
GearCheckOptionsEnableRecheck:SetPoint("TOPLEFT", GearCheckOptionsText4, "BOTTOMLEFT", 25, -5);

local GearCheckOptionsCheckButtonEnableRecheck = CreateFrame("CHECKBUTTON", "GearCheckOptionsCheckButtonEnableRecheck", GearCheckOptionsFrame);
GearCheckOptionsCheckButtonEnableRecheck:SetWidth(15);
GearCheckOptionsCheckButtonEnableRecheck:SetHeight(15);
GearCheckOptionsCheckButtonEnableRecheck:SetPoint("RIGHT", GearCheckOptionsEnableRecheck, "LEFT", -5, 0);
GearCheckOptionsCheckButtonEnableRecheck:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonEnableRecheck:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonEnableRecheck:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonEnableRecheck:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonEnableRecheck:SetScript("OnClick", function() 
																GearCheck_EnableRecheck = GearChecktobool(GearCheckOptionsCheckButtonEnableRecheck:GetChecked());															
															 end);
GearCheckOptionsCheckButtonEnableRecheck:Show();

local GearCheckOptionsNumInspections = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsNumInspections:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsNumInspections:SetWidth(185);
GearCheckOptionsNumInspections:SetJustifyH("LEFT");
GearCheckOptionsNumInspections:SetText(L["NumInspections"]);
GearCheckOptionsNumInspections:SetPoint("TOPLEFT", GearCheckOptionsEnableRecheck, "BOTTOMLEFT", -20, -5);

local GearCheckOptionsNumInspectionsBox = CreateFrame("EDITBOX", "GearCheckOptionsNumInspectionsBox", GearCheckOptionsFrame, "InputBoxTemplate")
GearCheckOptionsNumInspectionsBox:SetWidth(30);
GearCheckOptionsNumInspectionsBox:SetHeight(15);
GearCheckOptionsNumInspectionsBox:SetPoint("LEFT", GearCheckOptionsNumInspections, "RIGHT", -50, 0);
GearCheckOptionsNumInspectionsBox:SetNumeric(true);
GearCheckOptionsNumInspectionsBox:SetMaxLetters(2);
GearCheckOptionsNumInspectionsBox:SetScript("OnEnterPressed", function() GearCheckOptionsNumInspectionsBox:ClearFocus(); end);
GearCheckOptionsNumInspectionsBox:SetScript("OnEditFocusLost", function() 
																	local n = GearCheckOptionsNumInspectionsBox:GetNumber();
																	if n < 1 then
																		n = GearCheckDefaultNumInspections;
																		GearCheckOptionsNumInspectionsBox:SetNumber(n);
																	elseif n > 15 then
																		n = GearCheckDefaultNumInspections;
																		GearCheckOptionsNumInspectionsBox:SetNumber(n);
																	end
																	GearCheckNumInspections = n;
																end);
GearCheckOptionsNumInspectionsBox:SetAutoFocus(false);
GearCheckOptionsNumInspectionsBox:Show();

local GearCheckOptionsAdditionalWaittime = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsAdditionalWaittime:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsAdditionalWaittime:SetWidth(185);
GearCheckOptionsAdditionalWaittime:SetJustifyH("LEFT");
GearCheckOptionsAdditionalWaittime:SetText(L["additionalWaittime"]);
GearCheckOptionsAdditionalWaittime:SetPoint("TOPLEFT", GearCheckOptionsNumInspections, "BOTTOMLEFT", 0, -5);

local GearCheckOptionsAdditionalWaittimeBox = CreateFrame("EDITBOX", "GearCheckOptionsAdditionalWaittimeBox", GearCheckOptionsFrame, "InputBoxTemplate")
GearCheckOptionsAdditionalWaittimeBox:SetWidth(30);
GearCheckOptionsAdditionalWaittimeBox:SetHeight(15);
GearCheckOptionsAdditionalWaittimeBox:SetPoint("LEFT", GearCheckOptionsAdditionalWaittime, "RIGHT", -50, 0);
GearCheckOptionsAdditionalWaittimeBox:SetMaxLetters(4);
GearCheckOptionsAdditionalWaittimeBox:SetScript("OnEnterPressed", function() GearCheckOptionsAdditionalWaittimeBox:ClearFocus(); end);
GearCheckOptionsAdditionalWaittimeBox:SetScript("OnEditFocusLost", function() 
																	local n = tonumber(GearCheckOptionsAdditionalWaittimeBox:GetText());
																	if n < 0.15 then
																		n = GearCheckDefaultAdditionalWaittime;
																		GearCheckOptionsAdditionalWaittimeBox:SetText(n);
																	elseif n > 2 then
																		n = GearCheckDefaultAdditionalWaittime;
																		GearCheckOptionsAdditionalWaittimeBox:SetText(n);
																	end																	
																	GearCheckAdditionalWaittime = n;
																end);
GearCheckOptionsAdditionalWaittimeBox:SetAutoFocus(false);
GearCheckOptionsAdditionalWaittimeBox:Show();

local GearCheckReportFrame = CreateFrame("FRAME", "GearCheckReportFrame", UIParent);
GearCheckReportFrame:SetFrameStrata("TOOLTIP"); 
GearCheckReportFrame:SetWidth(200);
GearCheckReportFrame:SetHeight(210);
GearCheckReportFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GearCheckReportFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
GearCheckReportFrame:SetPoint("CENTER");
GearCheckReportFrame:EnableMouse(true);
GearCheckReportFrame:RegisterForDrag("LeftButton");
GearCheckReportFrame:SetMovable(true);
GearCheckReportFrame:SetUserPlaced(true);
GearCheckReportFrame:SetScript("OnDragStart", function(this) this:StartMoving(); end);
GearCheckReportFrame:SetScript("OnDragStop", function(this) this:StopMovingOrSizing(); end);
GearCheckReportFrame:Hide();
tinsert(UISpecialFrames, GearCheckReportFrame:GetName());

local GearCheckReportFrameTop = CreateFrame("FRAME", nil, GearCheckReportFrame);
GearCheckReportFrameTop:SetWidth(120);
GearCheckReportFrameTop:SetHeight(25);
GearCheckReportFrameTop:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GearCheckReportFrameTop:SetBackdropColor(0.0,0.0,0.0,0.9);
GearCheckReportFrameTop:SetPoint("TOP", 0, 10);
GearCheckReportFrameTop:Show();

local GearCheckReportFrameText = GearCheckReportFrameTop:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckReportFrameText:SetTextColor(1, 0, 0, 1.0);
GearCheckReportFrameText:SetText(L["Report"]);
GearCheckReportFrameText:SetPoint("CENTER");

local GearCheckReportFrameClose = CreateFrame("BUTTON", nil, GearCheckReportFrame, "UIPanelButtonTemplate");
GearCheckReportFrameClose:SetWidth(15);
GearCheckReportFrameClose:SetHeight(15);
GearCheckReportFrameClose:SetText("X");
GearCheckReportFrameClose:SetPoint("TOPRIGHT", -5, -5);
GearCheckReportFrameClose:SetScript("OnClick", function()
											GearCheckReportFrame:Hide();											
										   end);
GearCheckReportFrameClose:SetAlpha(1);
GearCheckReportFrameClose:Show();

local GearCheckReportFrameText = GearCheckReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckReportFrameText:SetTextColor(1.0, 0.8, 0, 0.8);
GearCheckReportFrameText:SetWidth(175);
GearCheckReportFrameText:SetJustifyH("LEFT");
GearCheckReportFrameText:SetText(L["Report:"]);
GearCheckReportFrameText:SetPoint("TOPLEFT", 5, -30);

local GearCheckReportFrameChatFrame = GearCheckReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckReportFrameChatFrame:SetTextColor(1, 1, 1, 0.8);
GearCheckReportFrameChatFrame:SetWidth(175);
GearCheckReportFrameChatFrame:SetHeight(15);
GearCheckReportFrameChatFrame:SetJustifyH("LEFT");
GearCheckReportFrameChatFrame:SetText(L["ChatFrame1"]);
GearCheckReportFrameChatFrame:SetPoint("TOP", GearCheckReportFrameText, "BOTTOM", 25, -5);

local GearCheckReportFrameCheckButtonChatFrame = CreateFrame("CHECKBUTTON", "GearCheckReportFrameCheckButtonChatFrame", GearCheckReportFrame);
GearCheckReportFrameCheckButtonChatFrame:SetWidth(15);
GearCheckReportFrameCheckButtonChatFrame:SetHeight(15);
GearCheckReportFrameCheckButtonChatFrame:SetPoint("RIGHT", GearCheckReportFrameChatFrame, "LEFT", -5, 0);
GearCheckReportFrameCheckButtonChatFrame:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckReportFrameCheckButtonChatFrame:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckReportFrameCheckButtonChatFrame:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckReportFrameCheckButtonChatFrame:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckReportFrameCheckButtonChatFrame:SetScript("OnClick", function() GearCheckReportTo["ChatFrame1"] = GearChecktobool(GearCheckReportFrameCheckButtonChatFrame:GetChecked()); end);
GearCheckReportFrameCheckButtonChatFrame:Show();

local GearCheckReportFrameSay = GearCheckReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckReportFrameSay:SetTextColor(1, 1, 1, 0.8);
GearCheckReportFrameSay:SetWidth(175);
GearCheckReportFrameSay:SetHeight(15);
GearCheckReportFrameSay:SetJustifyH("LEFT");
GearCheckReportFrameSay:SetText(L["/say"]);
GearCheckReportFrameSay:SetPoint("TOP", GearCheckReportFrameChatFrame, "BOTTOM", 0, 0);

local GearCheckReportFrameCheckButtonSay = CreateFrame("CHECKBUTTON", "GearCheckReportFrameCheckButtonSay", GearCheckReportFrame);
GearCheckReportFrameCheckButtonSay:SetWidth(15);
GearCheckReportFrameCheckButtonSay:SetHeight(15);
GearCheckReportFrameCheckButtonSay:SetPoint("RIGHT", GearCheckReportFrameSay, "LEFT", -5, 0);
GearCheckReportFrameCheckButtonSay:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckReportFrameCheckButtonSay:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckReportFrameCheckButtonSay:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckReportFrameCheckButtonSay:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckReportFrameCheckButtonSay:SetScript("OnClick", function() GearCheckReportTo["Say"] = GearChecktobool(GearCheckReportFrameCheckButtonSay:GetChecked()); end);
GearCheckReportFrameCheckButtonSay:Show();

local GearCheckReportFrameYell = GearCheckReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckReportFrameYell:SetTextColor(1, 1, 1, 0.8);
GearCheckReportFrameYell:SetWidth(175);
GearCheckReportFrameYell:SetHeight(15);
GearCheckReportFrameYell:SetJustifyH("LEFT");
GearCheckReportFrameYell:SetText(L["/yell"]);
GearCheckReportFrameYell:SetPoint("TOP", GearCheckReportFrameSay, "BOTTOM", 0, 0);

local GearCheckReportFrameCheckButtonYell = CreateFrame("CHECKBUTTON", "GearCheckReportFrameCheckButtonYell", GearCheckReportFrame);
GearCheckReportFrameCheckButtonYell:SetWidth(15);
GearCheckReportFrameCheckButtonYell:SetHeight(15);
GearCheckReportFrameCheckButtonYell:SetPoint("RIGHT", GearCheckReportFrameYell, "LEFT", -5, 0);
GearCheckReportFrameCheckButtonYell:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckReportFrameCheckButtonYell:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckReportFrameCheckButtonYell:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckReportFrameCheckButtonYell:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckReportFrameCheckButtonYell:SetScript("OnClick", function() GearCheckReportTo["Yell"] = GearChecktobool(GearCheckReportFrameCheckButtonYell:GetChecked()); end);
GearCheckReportFrameCheckButtonYell:Show();

local GearCheckReportFrameParty = GearCheckReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckReportFrameParty:SetTextColor(1, 1, 1, 0.8);
GearCheckReportFrameParty:SetWidth(175);
GearCheckReportFrameParty:SetHeight(15);
GearCheckReportFrameParty:SetJustifyH("LEFT");
GearCheckReportFrameParty:SetText(L["/party"]);
GearCheckReportFrameParty:SetPoint("TOP", GearCheckReportFrameYell, "BOTTOM", 0, 0);

local GearCheckReportFrameCheckButtonParty = CreateFrame("CHECKBUTTON", "GearCheckReportFrameCheckButtonParty", GearCheckReportFrame);
GearCheckReportFrameCheckButtonParty:SetWidth(15);
GearCheckReportFrameCheckButtonParty:SetHeight(15);
GearCheckReportFrameCheckButtonParty:SetPoint("RIGHT", GearCheckReportFrameParty, "LEFT", -5, 0);
GearCheckReportFrameCheckButtonParty:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckReportFrameCheckButtonParty:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckReportFrameCheckButtonParty:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckReportFrameCheckButtonParty:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckReportFrameCheckButtonParty:SetScript("OnClick", function() GearCheckReportTo["Party"] = GearChecktobool(GearCheckReportFrameCheckButtonParty:GetChecked()); end);
GearCheckReportFrameCheckButtonParty:Show();

local GearCheckReportFrameRaidtxt = GearCheckReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckReportFrameRaidtxt:SetTextColor(1, 1, 1, 0.8);
GearCheckReportFrameRaidtxt:SetWidth(175);
GearCheckReportFrameRaidtxt:SetHeight(15);
GearCheckReportFrameRaidtxt:SetJustifyH("LEFT");
GearCheckReportFrameRaidtxt:SetText(L["/raid"]);
GearCheckReportFrameRaidtxt:SetPoint("TOP", GearCheckReportFrameParty, "BOTTOM", 0, 0);

local GearCheckReportFrameCheckButtonRaid = CreateFrame("CHECKBUTTON", "GearCheckReportFrameCheckButtonRaid", GearCheckReportFrame);
GearCheckReportFrameCheckButtonRaid:SetWidth(15);
GearCheckReportFrameCheckButtonRaid:SetHeight(15);
GearCheckReportFrameCheckButtonRaid:SetPoint("RIGHT", GearCheckReportFrameRaidtxt, "LEFT", -5, 0);
GearCheckReportFrameCheckButtonRaid:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckReportFrameCheckButtonRaid:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckReportFrameCheckButtonRaid:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckReportFrameCheckButtonRaid:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");	
GearCheckReportFrameCheckButtonRaid:SetScript("OnClick", function() GearCheckReportTo["Raid"] = GearChecktobool(GearCheckReportFrameCheckButtonRaid:GetChecked()); end);
GearCheckReportFrameCheckButtonRaid:Show();

local GearCheckReportFrameGuild = GearCheckReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckReportFrameGuild:SetTextColor(1, 1, 1, 0.8);
GearCheckReportFrameGuild:SetWidth(175);
GearCheckReportFrameGuild:SetHeight(15);
GearCheckReportFrameGuild:SetJustifyH("LEFT");
GearCheckReportFrameGuild:SetText(L["/guild"]);
GearCheckReportFrameGuild:SetPoint("TOP", GearCheckReportFrameRaidtxt, "BOTTOM", 0, 0);

local GearCheckReportFrameCheckButtonGuild = CreateFrame("CHECKBUTTON", "GearCheckReportFrameCheckButtonGuild", GearCheckReportFrame);
GearCheckReportFrameCheckButtonGuild:SetWidth(15);
GearCheckReportFrameCheckButtonGuild:SetHeight(15);
GearCheckReportFrameCheckButtonGuild:SetPoint("RIGHT", GearCheckReportFrameGuild, "LEFT", -5, 0);
GearCheckReportFrameCheckButtonGuild:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckReportFrameCheckButtonGuild:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckReportFrameCheckButtonGuild:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckReportFrameCheckButtonGuild:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckReportFrameCheckButtonGuild:SetScript("OnClick", function() GearCheckReportTo["Guild"] = GearChecktobool(GearCheckReportFrameCheckButtonGuild:GetChecked()); end);
GearCheckReportFrameCheckButtonGuild:Show();

local GearCheckReportFrameWhisper = GearCheckReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckReportFrameWhisper:SetTextColor(1, 1, 1, 0.8);
GearCheckReportFrameWhisper:SetWidth(100);
GearCheckReportFrameWhisper:SetHeight(15);
GearCheckReportFrameWhisper:SetJustifyH("LEFT");
GearCheckReportFrameWhisper:SetText(L["/whisper:"]);
GearCheckReportFrameWhisper:SetPoint("TOPLEFT", GearCheckReportFrameGuild, "BOTTOMLEFT");

local GearCheckReportFrameCheckButtonWhisper = CreateFrame("CHECKBUTTON", "GearCheckReportFrameCheckButtonWhisper", GearCheckReportFrame);
GearCheckReportFrameCheckButtonWhisper:SetWidth(15);
GearCheckReportFrameCheckButtonWhisper:SetHeight(15);
GearCheckReportFrameCheckButtonWhisper:SetPoint("RIGHT", GearCheckReportFrameWhisper, "LEFT", -5, 0);
GearCheckReportFrameCheckButtonWhisper:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckReportFrameCheckButtonWhisper:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckReportFrameCheckButtonWhisper:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckReportFrameCheckButtonWhisper:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckReportFrameCheckButtonWhisper:SetScript("OnClick", function() GearCheckReportTo["Whisper"] = GearChecktobool(GearCheckReportFrameCheckButtonWhisper:GetChecked()); end);
GearCheckReportFrameCheckButtonWhisper:Show();

local GearCheckReportFrameWhisperBox = CreateFrame("EDITBOX", "GearCheckReportFrameWhisperBox", GearCheckReportFrame, "InputBoxTemplate")
GearCheckReportFrameWhisperBox:SetWidth(90);
GearCheckReportFrameWhisperBox:SetHeight(15);
GearCheckReportFrameWhisperBox:SetPoint("LEFT", GearCheckReportFrameWhisper, "RIGHT", -40, -2);
GearCheckReportFrameWhisperBox:SetMaxLetters(12);
GearCheckReportFrameWhisperBox:SetScript("OnTabPressed", function()
													local n, r = UnitName("TARGET");
														if not (n == nil) then
														GearCheckReportFrameWhisperBox:SetText(n);
													end
												end);

GearCheckReportFrameWhisperBox:SetScript("OnEnterPressed", function() GearCheckReportFrameWhisperBox:ClearFocus(); end);
GearCheckReportFrameWhisperBox:SetScript("OnTextChanged", function()
	local h = GearCheckReportFrameWhisperBox:GetText()
	if #h == 1 then
		GearCheckReportFrameWhisperBox:SetText(strupper(h));
	elseif #h > 1 then
		local a = strsub(h, 1, 1);
		local b = strsub(h, 2);		
		GearCheckReportFrameWhisperBox:SetText(strupper(a)..strlower(b));
	end
	GearCheckWhisperBox = GearCheckReportFrameWhisperBox:GetText();
end);
GearCheckReportFrameWhisperBox:SetAutoFocus(false);
GearCheckReportFrameWhisperBox:Show();

local GearCheckReportFrameReportButton = CreateFrame("BUTTON", "GearCheckReportFrameReportButton", GearCheckReportFrame, "UIPanelButtonTemplate");
GearCheckReportFrameReportButton:SetWidth(180);
GearCheckReportFrameReportButton:SetHeight(30);
GearCheckReportFrameReportButton:SetText(L["report"]);
GearCheckReportFrameReportButton:SetPoint("BOTTOM", GearCheckReportFrame, "BOTTOM", 0, 10);
GearCheckReportFrameReportButton:SetScript("OnClick", function() 
													GearCheckReportFrameReportButton:Disable();
													GearCheckReportData();
													GearCheckWait(5, GearCheckReportFrameReportButtonEnable);
												end);
GearCheckReportFrameReportButton:SetAlpha(1);
GearCheckReportFrameReportButton:Show();


local GearCheckHelpFrame = CreateFrame("FRAME", "GearCheckHelpFrame", UIParent);
GearCheckHelpFrame:SetFrameStrata("TOOLTIP"); 
GearCheckHelpFrame:SetWidth(250);
GearCheckHelpFrame:SetHeight(130);
GearCheckHelpFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GearCheckHelpFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
GearCheckHelpFrame:SetPoint("BOTTOM", GearCheckFrame, "TOP", 0, 0);
GearCheckHelpFrame:SetScript("OnDragStart", function(this) this:StartMoving(); end);
GearCheckHelpFrame:SetScript("OnDragStop", function(this) this:StopMovingOrSizing(); end);
GearCheckHelpFrame:Hide();
tinsert(UISpecialFrames, GearCheckHelpFrame:GetName());

local GearCheckHelpFrameText = GearCheckHelpFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckHelpFrameText:SetTextColor(1.0, 0.8, 0, 0.8);
GearCheckHelpFrameText:SetWidth(230);
GearCheckHelpFrameText:SetJustifyH("LEFT");
GearCheckHelpFrameText:SetText(L["Help"]);
GearCheckHelpFrameText:SetPoint("TOPLEFT", 5, -10);
-- end UI
